

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.acquisition;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="otf_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="otf_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="otf_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="otf_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="otf_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="otf_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="otf_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="otf_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
        "id IN (SELECT otf.id FROM otf*, image* WHERE " +
        "otf.instrument = image.instrument AND image.id IN (:images)))")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "otf", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_otf",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_otf"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class OTF
implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "otf_owner_filter";
    public final static String GROUP_FILTER = "otf_group_filter";
    public final static String EVENT_FILTER = "otf_event_filter";
    public final static String PERMS_FILTER = "otf_perms_filter";

    public OTF () {
        this(null, true);
    }

    protected OTF (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public OTF (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public OTF(
java.lang.Integer _sizeX,java.lang.Integer _sizeY,java.lang.Boolean _opticalAxisAveraged,ome.model.enums.PixelsType _pixelsType,java.lang.String _path,ome.model.acquisition.Objective _objective,ome.model.acquisition.Instrument _instrument    ) {
        this(null, true);
        setSizeX(_sizeX);
        setSizeY(_sizeY);
        setOpticalAxisAveraged(_opticalAxisAveraged);
        setPixelsType(_pixelsType);
        setPath(_path);
        setObjective(_objective);
        setInstrument(_instrument);
    }

    public final static String ID = "ome.model.acquisition.OTF_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_otf") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.acquisition.OTF_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.Integer sizeX = null;

   /**
    * Simple field ome.model.acquisition.OTF.sizeX (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="positive_int", nullable=false, unique=false, name="sizeX", updatable=true)
    public java.lang.Integer getSizeX() {
        if (! _loaded ) errorIfUnloaded();
        return this.sizeX;
    }

    public void setSizeX(java.lang.Integer sizeX) {
        if (! _loaded ) errorIfUnloaded();
        if (sizeX != null && sizeX <= 0) {
            throw new IllegalArgumentException("values of OTF.sizeX must be strictly positive");
        }
        this.sizeX = (java.lang.Integer) sizeX;
    }
    protected java.lang.Integer sizeY = null;

   /**
    * Simple field ome.model.acquisition.OTF.sizeY (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="positive_int", nullable=false, unique=false, name="sizeY", updatable=true)
    public java.lang.Integer getSizeY() {
        if (! _loaded ) errorIfUnloaded();
        return this.sizeY;
    }

    public void setSizeY(java.lang.Integer sizeY) {
        if (! _loaded ) errorIfUnloaded();
        if (sizeY != null && sizeY <= 0) {
            throw new IllegalArgumentException("values of OTF.sizeY must be strictly positive");
        }
        this.sizeY = (java.lang.Integer) sizeY;
    }
    protected java.lang.Boolean opticalAxisAveraged = null;

   /**
    * Simple field ome.model.acquisition.OTF.opticalAxisAveraged (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="opticalAxisAveraged", updatable=true)
    public java.lang.Boolean getOpticalAxisAveraged() {
        if (! _loaded ) errorIfUnloaded();
        return this.opticalAxisAveraged;
    }

    public void setOpticalAxisAveraged(java.lang.Boolean opticalAxisAveraged) {
        if (! _loaded ) errorIfUnloaded();
        this.opticalAxisAveraged = (java.lang.Boolean) opticalAxisAveraged;
    }
    protected ome.model.enums.PixelsType pixelsType = null;

   /**
    * Many-to-one field ome.model.acquisition.OTF.pixelsType (ome.model.enums.PixelsType)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.PixelsType.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="pixelsType", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKotf_pixelsType_pixelstype")
    public ome.model.enums.PixelsType getPixelsType() {
        if (! _loaded ) errorIfUnloaded();
        return this.pixelsType;
    }

    public void setPixelsType(ome.model.enums.PixelsType pixelsType) {
        if (! _loaded ) errorIfUnloaded();
        this.pixelsType = pixelsType;
    }
    protected java.lang.String path = null;

   /**
    * Simple field ome.model.acquisition.OTF.path (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="path", updatable=true)
    public java.lang.String getPath() {
        if (! _loaded ) errorIfUnloaded();
        return this.path;
    }

    public void setPath(java.lang.String path) {
        if (! _loaded ) errorIfUnloaded();
        this.path = (java.lang.String) path;
    }
    protected ome.model.acquisition.FilterSet filterSet = null;

   /**
    * Many-to-one field ome.model.acquisition.OTF.filterSet (ome.model.acquisition.FilterSet)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.FilterSet.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="filterSet", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKotf_filterSet_filterset")
    public ome.model.acquisition.FilterSet getFilterSet() {
        if (! _loaded ) errorIfUnloaded();
        return this.filterSet;
    }

    public void setFilterSet(ome.model.acquisition.FilterSet filterSet) {
        if (! _loaded ) errorIfUnloaded();
        this.filterSet = filterSet;
    }
    protected ome.model.acquisition.Objective objective = null;

   /**
    * Many-to-one field ome.model.acquisition.OTF.objective (ome.model.acquisition.Objective)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.Objective.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="objective", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKotf_objective_objective")
    public ome.model.acquisition.Objective getObjective() {
        if (! _loaded ) errorIfUnloaded();
        return this.objective;
    }

    public void setObjective(ome.model.acquisition.Objective objective) {
        if (! _loaded ) errorIfUnloaded();
        this.objective = objective;
    }
    protected ome.model.acquisition.Instrument instrument = null;

   /**
    * Many-to-one field ome.model.acquisition.OTF.instrument (ome.model.acquisition.Instrument)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.acquisition.Instrument.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="instrument", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKotf_instrument_instrument")
    public ome.model.acquisition.Instrument getInstrument() {
        if (! _loaded ) errorIfUnloaded();
        return this.instrument;
    }

    public void setInstrument(ome.model.acquisition.Instrument instrument) {
        if (! _loaded ) errorIfUnloaded();
        this.instrument = instrument;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.acquisition.OTF newInstance()
    {
        return new ome.model.acquisition.OTF();
    }

    public ome.model.acquisition.OTF proxy() {
        return new ome.model.acquisition.OTF(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.sizeX = (java.lang.Integer) __filter.filter(SIZEX, this.sizeX );
            this.sizeY = (java.lang.Integer) __filter.filter(SIZEY, this.sizeY );
            this.opticalAxisAveraged = (java.lang.Boolean) __filter.filter(OPTICALAXISAVERAGED, this.opticalAxisAveraged );
            this.pixelsType = (ome.model.enums.PixelsType) __filter.filter(PIXELSTYPE, this.pixelsType );
            this.path = (java.lang.String) __filter.filter(PATH, this.path );
            this.filterSet = (ome.model.acquisition.FilterSet) __filter.filter(FILTERSET, this.filterSet );
            this.objective = (ome.model.acquisition.Objective) __filter.filter(OBJECTIVE, this.objective );
            this.instrument = (ome.model.acquisition.Instrument) __filter.filter(INSTRUMENT, this.instrument );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.acquisition.OTF.FIELDS;
    }

    public final static String SIZEX = "ome.model.acquisition.OTF_sizeX";
    public final static String SIZEY = "ome.model.acquisition.OTF_sizeY";
    public final static String OPTICALAXISAVERAGED = "ome.model.acquisition.OTF_opticalAxisAveraged";
    public final static String PIXELSTYPE = "ome.model.acquisition.OTF_pixelsType";
    public final static String PATH = "ome.model.acquisition.OTF_path";
    public final static String FILTERSET = "ome.model.acquisition.OTF_filterSet";
    public final static String OBJECTIVE = "ome.model.acquisition.OTF_objective";
    public final static String INSTRUMENT = "ome.model.acquisition.OTF_instrument";
    public final static String DETAILS = "ome.model.acquisition.OTF_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(SIZEX);
       raw.add(SIZEY);
       raw.add(OPTICALAXISAVERAGED);
       raw.add(PIXELSTYPE);
       raw.add(PATH);
       raw.add(FILTERSET);
       raw.add(OBJECTIVE);
       raw.add(INSTRUMENT);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(SIZEX)) {
            return getSizeX();
        } else if (field.equals(SIZEY)) {
            return getSizeY();
        } else if (field.equals(OPTICALAXISAVERAGED)) {
            return getOpticalAxisAveraged();
        } else if (field.equals(PIXELSTYPE)) {
            return getPixelsType();
        } else if (field.equals(PATH)) {
            return getPath();
        } else if (field.equals(FILTERSET)) {
            return getFilterSet();
        } else if (field.equals(OBJECTIVE)) {
            return getObjective();
        } else if (field.equals(INSTRUMENT)) {
            return getInstrument();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(SIZEX)) {
            setSizeX((java.lang.Integer)value);
        } else if (field.equals(SIZEY)) {
            setSizeY((java.lang.Integer)value);
        } else if (field.equals(OPTICALAXISAVERAGED)) {
            setOpticalAxisAveraged((java.lang.Boolean)value);
        } else if (field.equals(PIXELSTYPE)) {
            setPixelsType((ome.model.enums.PixelsType)value);
        } else if (field.equals(PATH)) {
            setPath((java.lang.String)value);
        } else if (field.equals(FILTERSET)) {
            setFilterSet((ome.model.acquisition.FilterSet)value);
        } else if (field.equals(OBJECTIVE)) {
            setObjective((ome.model.acquisition.Objective)value);
        } else if (field.equals(INSTRUMENT)) {
            setInstrument((ome.model.acquisition.Instrument)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.sizeX = null;
        this.sizeY = null;
        this.opticalAxisAveraged = null;
        this.pixelsType = null;
        this.path = null;
        this.filterSet = null;
        this.objective = null;
        this.instrument = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKotf_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKotf_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKotf_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKotf_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKotf_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
