

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.containers;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="folder_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="folder_owner_filter_CHILDFOLDERS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_group_filter_CHILDFOLDERS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_event_filter_CHILDFOLDERS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_perms_filter_CHILDFOLDERS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="folder_owner_filter_IMAGELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_group_filter_IMAGELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_event_filter_IMAGELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_perms_filter_IMAGELINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="folder_owner_filter_ROILINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_group_filter_ROILINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_event_filter_ROILINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_perms_filter_ROILINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="folder_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="folder_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="folder_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="folder_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="folder_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="folder_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "folder", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_folder",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_folder"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Folder
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "folder_owner_filter";
    public final static String GROUP_FILTER = "folder_group_filter";
    public final static String EVENT_FILTER = "folder_event_filter";
    public final static String PERMS_FILTER = "folder_perms_filter";

    public Folder () {
        this(null, true);
    }

    protected Folder (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Folder (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Folder(
java.lang.String _name    ) {
        this(null, true);
        setName(_name);
    }

    public final static String ID = "ome.model.containers.Folder_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_folder") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.containers.Folder_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.util.Set<ome.model.containers.Folder> childFolders = new java.util.HashSet<ome.model.containers.Folder>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_CHILDFOLDERS = "folder_owner_filter_CHILDFOLDERS";
    public final static String GROUP_FILTER_CHILDFOLDERS = "folder_group_filter_CHILDFOLDERS";
    public final static String EVENT_FILTER_CHILDFOLDERS = "folder_event_filter_CHILDFOLDERS";
    public final static String PERMS_FILTER_CHILDFOLDERS = "folder_perms_filter_CHILDFOLDERS";

   /**
    * returns childFolders . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.containers.Folder.childFolders (ome.model.containers.Folder)
    */
    @javax.persistence.OneToMany(mappedBy="parentFolder", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_CHILDFOLDERS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_CHILDFOLDERS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_CHILDFOLDERS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_CHILDFOLDERS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.containers.Folder> getChildFolders() {
        if (! _loaded ) errorIfUnloaded();
        return this.childFolders;
    }

    /**
     * setter for childFolders should be avoided. Does not fulfill normal semantics.
     */
    protected void setChildFolders(java.util.Set<ome.model.containers.Folder> childFolders) {
        if (! _loaded ) errorIfUnloaded();
        this.childFolders = childFolders;
    }
    /**
     * returns the size of childFolders. If less than zero, the Set was null.
     */
    public int sizeOfChildFolders() {
        if (! _loaded ) errorIfUnloaded();
        return this.childFolders == null ? -1 : this.childFolders.size();
    }

    /**
     * should be used rather than accessing the childFolders set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfChildFolders()} is less than zero.
     */
    public java.util.Iterator<ome.model.containers.Folder> iterateChildFolders() {
        if (! _loaded ) errorIfUnloaded();
        if ( getChildFolders() == null ) {
            return new ome.util.EmptyIterator<ome.model.containers.Folder>();
        }
        return getChildFolders().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.containers.Folder> unmodifiableChildFolders() {
        if (! _loaded ) errorIfUnloaded();
        if ( getChildFolders() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getChildFolders() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.containers.Folder while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateChildFolders} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectChildFolders(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.containers.Folder> it = iterateChildFolders();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setChildFolders . Makes the necessary
     * call on ome.model.containers.Folder as well.
     */
    public void addChildFolders(ome.model.containers.Folder target) {
        if (! _loaded ) errorIfUnloaded();
        if (getChildFolders() == null) {
            throwNullCollectionException("ChildFolders");
        }
        getChildFolders().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParentFolder ( this );
         }
    }

    /**
     * use like addFolder.
     */
    public void addChildFoldersSet(java.util.Collection<ome.model.containers.Folder> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getChildFolders() == null) {
           throwNullCollectionException("ChildFolders");
        }
        getChildFolders().addAll( targets );
        java.util.Iterator<ome.model.containers.Folder> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.Folder target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParentFolder ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.containers.Folder
     */
    public void removeChildFolders(ome.model.containers.Folder target) {
        if (! _loaded ) errorIfUnloaded();
        if (getChildFolders() == null) {
            throwNullCollectionException("ChildFolders");
        }
        getChildFolders().remove( target );
            target.setParentFolder ( null );
    }

    /**
     * use like removeFolder
     */
    public void removeChildFoldersSet(java.util.Collection<ome.model.containers.Folder> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getChildFolders() == null) {
            throwNullCollectionException("ChildFolders");
        }
        getChildFolders().removeAll( targets );
        java.util.Iterator<ome.model.containers.Folder> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.Folder target = it.next();
                target.setParentFolder ( null );
        }
    }

    /**
     * clears the set.
     */
    public void clearChildFolders() {
        if (! _loaded ) errorIfUnloaded();
        if (getChildFolders() == null) {
            throwNullCollectionException("ChildFolders");
        }
        getChildFolders().clear();
        java.util.Iterator<ome.model.containers.Folder> it = iterateChildFolders();
        while (it.hasNext()) {
            ome.model.containers.Folder target = it.next();
            target.setParentFolder ( null );
        }
    }


    protected ome.model.containers.Folder parentFolder = null;

   /**
    * Many-to-one field ome.model.containers.Folder.parentFolder (ome.model.containers.Folder)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.containers.Folder.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="parentFolder", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKfolder_parentFolder_folder")
    public ome.model.containers.Folder getParentFolder() {
        if (! _loaded ) errorIfUnloaded();
        return this.parentFolder;
    }

    public void setParentFolder(ome.model.containers.Folder parentFolder) {
        if (! _loaded ) errorIfUnloaded();
        this.parentFolder = parentFolder;
    }
    protected java.util.Set<ome.model.containers.FolderImageLink> imageLinks = new java.util.HashSet<ome.model.containers.FolderImageLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_IMAGELINKS = "folder_owner_filter_IMAGELINKS";
    public final static String GROUP_FILTER_IMAGELINKS = "folder_group_filter_IMAGELINKS";
    public final static String EVENT_FILTER_IMAGELINKS = "folder_event_filter_IMAGELINKS";
    public final static String PERMS_FILTER_IMAGELINKS = "folder_perms_filter_IMAGELINKS";

   /**
    * returns imageLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.containers.Folder.imageLinks (ome.model.containers.FolderImageLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_IMAGELINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_IMAGELINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_IMAGELINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_IMAGELINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.containers.FolderImageLink> getImageLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.imageLinks;
    }

    /**
     * setter for imageLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setImageLinks(java.util.Set<ome.model.containers.FolderImageLink> imageLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.imageLinks = imageLinks;
    }
    /**
     * returns the size of imageLinks. If less than zero, the Set was null.
     */
    public int sizeOfImageLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.imageLinks == null ? -1 : this.imageLinks.size();
    }

    /**
     * should be used rather than accessing the imageLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfImageLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.containers.FolderImageLink> iterateImageLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getImageLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.containers.FolderImageLink>();
        }
        return getImageLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.containers.FolderImageLink> unmodifiableImageLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getImageLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getImageLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.containers.FolderImageLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateImageLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectImageLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.containers.FolderImageLink> it = iterateImageLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setImageLinks . Makes the necessary
     * call on ome.model.containers.FolderImageLink as well.
     */
    public void addFolderImageLink(ome.model.containers.FolderImageLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getImageLinks() == null) {
            throwNullCollectionException("ImageLinks");
        }
        getImageLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addFolderImageLink.
     */
    public void addFolderImageLinkSet(java.util.Collection<ome.model.containers.FolderImageLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getImageLinks() == null) {
           throwNullCollectionException("ImageLinks");
        }
        getImageLinks().addAll( targets );
        java.util.Iterator<ome.model.containers.FolderImageLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.FolderImageLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.containers.FolderImageLink
     */
    public void removeFolderImageLink(ome.model.containers.FolderImageLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getImageLinks() == null) {
            throwNullCollectionException("ImageLinks");
        }
        getImageLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeFolderImageLink
     */
    public void removeFolderImageLinkSet(java.util.Collection<ome.model.containers.FolderImageLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getImageLinks() == null) {
            throwNullCollectionException("ImageLinks");
        }
        getImageLinks().removeAll( targets );
        java.util.Iterator<ome.model.containers.FolderImageLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.FolderImageLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.containers.FolderImageLink to imageLinks . This entails changing our imageLinks Set,
     * creating a new ome.model.containers.FolderImageLink and calling linkImage on the ome.model.core.Image.
     */
    public ome.model.containers.FolderImageLink linkImage (ome.model.core.Image addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.containers.FolderImageLink link = new ome.model.containers.FolderImageLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addFolderImageLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.containers.FolderImageLink to imageLinks, allowing for recursion -- whether
     * or not addFolderImageLink will be called on the addition <b>if it is loaded</b>
     */
    public void addFolderImageLink (ome.model.containers.FolderImageLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getImageLinks() == null ) {
            throwNullCollectionException("ImageLinks");
        }
        getImageLinks().add( link );

        if ( bothSides && link.child().isLoaded() ) {
            link.child().addFolderImageLink( link, false );
        }
    }

    /**
     * provides an iterator over the parent values of the imageLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedImageList()} instead.
     */
     public java.util.Iterator<ome.model.core.Image> linkedImageIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getImageLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.core.Image>();
        }

        final java.util.Iterator<ome.model.containers.FolderImageLink> it = getImageLinks().iterator();
        return new java.util.Iterator<ome.model.core.Image>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.core.Image next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "imageLinks is null; no elements." );
                }
                ome.model.containers.FolderImageLink link = (ome.model.containers.FolderImageLink) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.containers.FolderImageLink which have the argument as their child.
     */
    public java.util.Set<ome.model.containers.FolderImageLink> findFolderImageLink( ome.model.core.Image target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.containers.FolderImageLink> it = iterateImageLinks();
        final java.util.Set<ome.model.containers.FolderImageLink> result = new java.util.HashSet<ome.model.containers.FolderImageLink>();
        while ( it.hasNext() ) {
            ome.model.containers.FolderImageLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedImageIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.core.Image> linkedImageList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.core.Image> it = linkedImageIterator();
        java.util.List<ome.model.core.Image> list = new java.util.ArrayList<ome.model.core.Image>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.core.Image while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedImage(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.core.Image> it = linkedImageIterator();
        while ( it.hasNext() ) {
            ome.model.core.Image obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.core.Image instances from this instance.
     */
    public void unlinkImage (ome.model.core.Image removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.containers.FolderImageLink> toRemove = findFolderImageLink( removal );
        java.util.Iterator<ome.model.containers.FolderImageLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeFolderImageLink( it.next(), true );
        }
    }

    /**
     * removes the given FolderImageLink from imageLinks, allowing for recursion -- whether
     * or not the removal will call unlinkFolder again <b>if loaded</b>.
     */
    public void removeFolderImageLink (ome.model.containers.FolderImageLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getImageLinks() == null ) {
            throwNullCollectionException("ImageLinks");
        }

        getImageLinks().remove( link );

        if ( bothSides && link.child().isLoaded() ) {
            link.child().removeFolderImageLink( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearImageLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.containers.FolderImageLink> list = new java.util.ArrayList<ome.model.containers.FolderImageLink>( getImageLinks() );
        for (ome.model.containers.FolderImageLink link : list) {
            removeFolderImageLink( link, true );
        }
    }

    private java.util.Map<Long, Long> imageLinksCountPerOwner = null;

    protected void setImageLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.imageLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Folder_imageLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.containers.FolderImageLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Folder_imageLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Folder_imageLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Folder_id"))
    public java.util.Map<Long, Long> getImageLinksCountPerOwner() {
        return this.imageLinksCountPerOwner;
    }

    protected java.util.Set<ome.model.containers.FolderRoiLink> roiLinks = new java.util.HashSet<ome.model.containers.FolderRoiLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ROILINKS = "folder_owner_filter_ROILINKS";
    public final static String GROUP_FILTER_ROILINKS = "folder_group_filter_ROILINKS";
    public final static String EVENT_FILTER_ROILINKS = "folder_event_filter_ROILINKS";
    public final static String PERMS_FILTER_ROILINKS = "folder_perms_filter_ROILINKS";

   /**
    * returns roiLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.containers.Folder.roiLinks (ome.model.containers.FolderRoiLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ROILINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ROILINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ROILINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ROILINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.containers.FolderRoiLink> getRoiLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.roiLinks;
    }

    /**
     * setter for roiLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setRoiLinks(java.util.Set<ome.model.containers.FolderRoiLink> roiLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.roiLinks = roiLinks;
    }
    /**
     * returns the size of roiLinks. If less than zero, the Set was null.
     */
    public int sizeOfRoiLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.roiLinks == null ? -1 : this.roiLinks.size();
    }

    /**
     * should be used rather than accessing the roiLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfRoiLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.containers.FolderRoiLink> iterateRoiLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getRoiLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.containers.FolderRoiLink>();
        }
        return getRoiLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.containers.FolderRoiLink> unmodifiableRoiLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getRoiLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getRoiLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.containers.FolderRoiLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateRoiLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectRoiLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.containers.FolderRoiLink> it = iterateRoiLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setRoiLinks . Makes the necessary
     * call on ome.model.containers.FolderRoiLink as well.
     */
    public void addFolderRoiLink(ome.model.containers.FolderRoiLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getRoiLinks() == null) {
            throwNullCollectionException("RoiLinks");
        }
        getRoiLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addFolderRoiLink.
     */
    public void addFolderRoiLinkSet(java.util.Collection<ome.model.containers.FolderRoiLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getRoiLinks() == null) {
           throwNullCollectionException("RoiLinks");
        }
        getRoiLinks().addAll( targets );
        java.util.Iterator<ome.model.containers.FolderRoiLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.FolderRoiLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.containers.FolderRoiLink
     */
    public void removeFolderRoiLink(ome.model.containers.FolderRoiLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getRoiLinks() == null) {
            throwNullCollectionException("RoiLinks");
        }
        getRoiLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeFolderRoiLink
     */
    public void removeFolderRoiLinkSet(java.util.Collection<ome.model.containers.FolderRoiLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getRoiLinks() == null) {
            throwNullCollectionException("RoiLinks");
        }
        getRoiLinks().removeAll( targets );
        java.util.Iterator<ome.model.containers.FolderRoiLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.FolderRoiLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.containers.FolderRoiLink to roiLinks . This entails changing our roiLinks Set,
     * creating a new ome.model.containers.FolderRoiLink and calling linkRoi on the ome.model.roi.Roi.
     */
    public ome.model.containers.FolderRoiLink linkRoi (ome.model.roi.Roi addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.containers.FolderRoiLink link = new ome.model.containers.FolderRoiLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addFolderRoiLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.containers.FolderRoiLink to roiLinks, allowing for recursion -- whether
     * or not addFolderRoiLink will be called on the addition <b>if it is loaded</b>
     */
    public void addFolderRoiLink (ome.model.containers.FolderRoiLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getRoiLinks() == null ) {
            throwNullCollectionException("RoiLinks");
        }
        getRoiLinks().add( link );

        if ( bothSides && link.child().isLoaded() ) {
            link.child().addFolderRoiLink( link, false );
        }
    }

    /**
     * provides an iterator over the parent values of the roiLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedRoiList()} instead.
     */
     public java.util.Iterator<ome.model.roi.Roi> linkedRoiIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getRoiLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.roi.Roi>();
        }

        final java.util.Iterator<ome.model.containers.FolderRoiLink> it = getRoiLinks().iterator();
        return new java.util.Iterator<ome.model.roi.Roi>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.roi.Roi next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "roiLinks is null; no elements." );
                }
                ome.model.containers.FolderRoiLink link = (ome.model.containers.FolderRoiLink) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.containers.FolderRoiLink which have the argument as their child.
     */
    public java.util.Set<ome.model.containers.FolderRoiLink> findFolderRoiLink( ome.model.roi.Roi target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.containers.FolderRoiLink> it = iterateRoiLinks();
        final java.util.Set<ome.model.containers.FolderRoiLink> result = new java.util.HashSet<ome.model.containers.FolderRoiLink>();
        while ( it.hasNext() ) {
            ome.model.containers.FolderRoiLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedRoiIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.roi.Roi> linkedRoiList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.roi.Roi> it = linkedRoiIterator();
        java.util.List<ome.model.roi.Roi> list = new java.util.ArrayList<ome.model.roi.Roi>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.roi.Roi while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedRoi(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.roi.Roi> it = linkedRoiIterator();
        while ( it.hasNext() ) {
            ome.model.roi.Roi obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.roi.Roi instances from this instance.
     */
    public void unlinkRoi (ome.model.roi.Roi removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.containers.FolderRoiLink> toRemove = findFolderRoiLink( removal );
        java.util.Iterator<ome.model.containers.FolderRoiLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeFolderRoiLink( it.next(), true );
        }
    }

    /**
     * removes the given FolderRoiLink from roiLinks, allowing for recursion -- whether
     * or not the removal will call unlinkFolder again <b>if loaded</b>.
     */
    public void removeFolderRoiLink (ome.model.containers.FolderRoiLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getRoiLinks() == null ) {
            throwNullCollectionException("RoiLinks");
        }

        getRoiLinks().remove( link );

        if ( bothSides && link.child().isLoaded() ) {
            link.child().removeFolderRoiLink( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearRoiLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.containers.FolderRoiLink> list = new java.util.ArrayList<ome.model.containers.FolderRoiLink>( getRoiLinks() );
        for (ome.model.containers.FolderRoiLink link : list) {
            removeFolderRoiLink( link, true );
        }
    }

    private java.util.Map<Long, Long> roiLinksCountPerOwner = null;

    protected void setRoiLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.roiLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Folder_roiLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.containers.FolderRoiLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Folder_roiLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Folder_roiLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Folder_id"))
    public java.util.Map<Long, Long> getRoiLinksCountPerOwner() {
        return this.roiLinksCountPerOwner;
    }

    protected java.util.Set<ome.model.annotations.FolderAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.FolderAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "folder_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "folder_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "folder_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "folder_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.containers.Folder.annotationLinks (ome.model.annotations.FolderAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.FolderAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.FolderAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.FolderAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.FolderAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.annotations.FolderAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.FolderAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.FolderAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.FolderAnnotationLink as well.
     */
    public void addFolderAnnotationLink(ome.model.annotations.FolderAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addFolderAnnotationLink.
     */
    public void addFolderAnnotationLinkSet(java.util.Collection<ome.model.annotations.FolderAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.FolderAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.FolderAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.FolderAnnotationLink
     */
    public void removeFolderAnnotationLink(ome.model.annotations.FolderAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeFolderAnnotationLink
     */
    public void removeFolderAnnotationLinkSet(java.util.Collection<ome.model.annotations.FolderAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.FolderAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.FolderAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.FolderAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.FolderAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.FolderAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.FolderAnnotationLink link = new ome.model.annotations.FolderAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addFolderAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.FolderAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addFolderAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addFolderAnnotationLink (ome.model.annotations.FolderAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.FolderAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.FolderAnnotationLink link = (ome.model.annotations.FolderAnnotationLink) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.FolderAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.FolderAnnotationLink> findFolderAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.FolderAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.FolderAnnotationLink> result = new java.util.HashSet<ome.model.annotations.FolderAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.FolderAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.FolderAnnotationLink> toRemove = findFolderAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.FolderAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeFolderAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given FolderAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkFolder again <b>if loaded</b>.
     */
    public void removeFolderAnnotationLink (ome.model.annotations.FolderAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.FolderAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.FolderAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.FolderAnnotationLink link : list) {
            removeFolderAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Folder_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.FolderAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Folder_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Folder_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Folder_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected java.lang.String name = null;

   /**
    * Simple field ome.model.containers.Folder.name (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="name", updatable=true)
    public java.lang.String getName() {
        if (! _loaded ) errorIfUnloaded();
        return this.name;
    }

    public void setName(java.lang.String name) {
        if (! _loaded ) errorIfUnloaded();
        this.name = (java.lang.String) name;
    }
    protected java.lang.String description = null;

   /**
    * Simple field ome.model.containers.Folder.description (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="description", updatable=true)
    public java.lang.String getDescription() {
        if (! _loaded ) errorIfUnloaded();
        return this.description;
    }

    public void setDescription(java.lang.String description) {
        if (! _loaded ) errorIfUnloaded();
        this.description = (java.lang.String) description;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.containers.Folder newInstance()
    {
        return new ome.model.containers.Folder();
    }

    public ome.model.containers.Folder proxy() {
        return new ome.model.containers.Folder(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.childFolders = (java.util.Set<ome.model.containers.Folder>) __filter.filter(CHILDFOLDERS, this.childFolders );
            this.parentFolder = (ome.model.containers.Folder) __filter.filter(PARENTFOLDER, this.parentFolder );
            this.imageLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(IMAGELINKSCOUNTPEROWNER, this.imageLinksCountPerOwner );
            this.imageLinks = (java.util.Set<ome.model.containers.FolderImageLink>) __filter.filter(IMAGELINKS, this.imageLinks );
            this.roiLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ROILINKSCOUNTPEROWNER, this.roiLinksCountPerOwner );
            this.roiLinks = (java.util.Set<ome.model.containers.FolderRoiLink>) __filter.filter(ROILINKS, this.roiLinks );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.FolderAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.name = (java.lang.String) __filter.filter(NAME, this.name );
            this.description = (java.lang.String) __filter.filter(DESCRIPTION, this.description );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.containers.Folder.FIELDS;
    }

    public final static String CHILDFOLDERS = "ome.model.containers.Folder_childFolders";
    public final static String PARENTFOLDER = "ome.model.containers.Folder_parentFolder";
    public final static String IMAGELINKSCOUNTPEROWNER = "ome.model.containers.Folder_imageLinksCountPerOwner";
    public final static String IMAGELINKS = "ome.model.containers.Folder_imageLinks";
    public final static String ROILINKSCOUNTPEROWNER = "ome.model.containers.Folder_roiLinksCountPerOwner";
    public final static String ROILINKS = "ome.model.containers.Folder_roiLinks";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.containers.Folder_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.containers.Folder_annotationLinks";
    public final static String NAME = "ome.model.containers.Folder_name";
    public final static String DESCRIPTION = "ome.model.containers.Folder_description";
    public final static String DETAILS = "ome.model.containers.Folder_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(CHILDFOLDERS);
       raw.add(PARENTFOLDER);
       raw.add(IMAGELINKSCOUNTPEROWNER);
       raw.add(IMAGELINKS);
       raw.add(ROILINKSCOUNTPEROWNER);
       raw.add(ROILINKS);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(NAME);
       raw.add(DESCRIPTION);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(CHILDFOLDERS)) {
            return getChildFolders();
        } else if (field.equals(PARENTFOLDER)) {
            return getParentFolder();
        } else if (field.equals(IMAGELINKSCOUNTPEROWNER)) {
            return getImageLinksCountPerOwner();
        } else if (field.equals(IMAGELINKS)) {
            return getImageLinks();
        } else if (field.equals(ROILINKSCOUNTPEROWNER)) {
            return getRoiLinksCountPerOwner();
        } else if (field.equals(ROILINKS)) {
            return getRoiLinks();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) {
            return getAnnotationLinks();
        } else if (field.equals(NAME)) {
            return getName();
        } else if (field.equals(DESCRIPTION)) {
            return getDescription();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(CHILDFOLDERS)) {
            setChildFolders((java.util.Set<ome.model.containers.Folder>)value);
        } else if (field.equals(PARENTFOLDER)) {
            setParentFolder((ome.model.containers.Folder)value);
        } else if (field.equals(IMAGELINKSCOUNTPEROWNER)) {
            setImageLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(IMAGELINKS)) {
            setImageLinks((java.util.Set<ome.model.containers.FolderImageLink>)value);
        } else if (field.equals(ROILINKSCOUNTPEROWNER)) {
            setRoiLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ROILINKS)) {
            setRoiLinks((java.util.Set<ome.model.containers.FolderRoiLink>)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.FolderAnnotationLink>)value);
        } else if (field.equals(NAME)) {
            setName((java.lang.String)value);
        } else if (field.equals(DESCRIPTION)) {
            setDescription((java.lang.String)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.childFolders = null;
        this.parentFolder = null;
        this.imageLinksCountPerOwner = null;
        this.imageLinks = null;
        this.roiLinksCountPerOwner = null;
        this.roiLinks = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.name = null;
        this.description = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKfolder_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKfolder_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKfolder_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKfolder_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKfolder_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
