

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.core;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="originalfile_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_owner_filter_PIXELSFILEMAPS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_group_filter_PIXELSFILEMAPS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_event_filter_PIXELSFILEMAPS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_perms_filter_PIXELSFILEMAPS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="originalfile_owner_filter_FILESETENTRIES",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_group_filter_FILESETENTRIES",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_event_filter_FILESETENTRIES",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_perms_filter_FILESETENTRIES",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="originalfile_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="originalfile_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="originalfile_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="originalfile_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="originalfile_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="originalfile_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
        "id IN (SELECT pofm.parent FROM pixelsoriginalfilemap AS pofm*, pixels* WHERE " +
        "pofm.child = pixels.id AND pixels.image IN (:images)))")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "originalfile", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_originalfile",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_originalfile"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class OriginalFile
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "originalfile_owner_filter";
    public final static String GROUP_FILTER = "originalfile_group_filter";
    public final static String EVENT_FILTER = "originalfile_event_filter";
    public final static String PERMS_FILTER = "originalfile_perms_filter";

    public OriginalFile () {
        this(null, true);
    }

    protected OriginalFile (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public OriginalFile (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public OriginalFile(
java.lang.String _path,java.lang.String _name    ) {
        this(null, true);
        setPath(_path);
        setName(_name);
    }

    public final static String ID = "ome.model.core.OriginalFile_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_originalfile") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.core.OriginalFile_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.util.Set<ome.model.core.PixelsOriginalFileMap> pixelsFileMaps = new java.util.HashSet<ome.model.core.PixelsOriginalFileMap>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_PIXELSFILEMAPS = "originalfile_owner_filter_PIXELSFILEMAPS";
    public final static String GROUP_FILTER_PIXELSFILEMAPS = "originalfile_group_filter_PIXELSFILEMAPS";
    public final static String EVENT_FILTER_PIXELSFILEMAPS = "originalfile_event_filter_PIXELSFILEMAPS";
    public final static String PERMS_FILTER_PIXELSFILEMAPS = "originalfile_perms_filter_PIXELSFILEMAPS";

   /**
    * returns pixelsFileMaps . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.core.OriginalFile.pixelsFileMaps (ome.model.core.PixelsOriginalFileMap)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
            "id IN (SELECT pofm.id FROM pixelsoriginalfilemap AS pofm*, pixels* WHERE " +
            "pofm.child = pixels.id AND pixels.image IN (:images)))"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_PIXELSFILEMAPS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_PIXELSFILEMAPS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_PIXELSFILEMAPS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_PIXELSFILEMAPS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.core.PixelsOriginalFileMap> getPixelsFileMaps() {
        if (! _loaded ) errorIfUnloaded();
        return this.pixelsFileMaps;
    }

    /**
     * setter for pixelsFileMaps should be avoided. Does not fulfill normal semantics.
     */
    protected void setPixelsFileMaps(java.util.Set<ome.model.core.PixelsOriginalFileMap> pixelsFileMaps) {
        if (! _loaded ) errorIfUnloaded();
        this.pixelsFileMaps = pixelsFileMaps;
    }
    /**
     * returns the size of pixelsFileMaps. If less than zero, the Set was null.
     */
    public int sizeOfPixelsFileMaps() {
        if (! _loaded ) errorIfUnloaded();
        return this.pixelsFileMaps == null ? -1 : this.pixelsFileMaps.size();
    }

    /**
     * should be used rather than accessing the pixelsFileMaps set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfPixelsFileMaps()} is less than zero.
     */
    public java.util.Iterator<ome.model.core.PixelsOriginalFileMap> iteratePixelsFileMaps() {
        if (! _loaded ) errorIfUnloaded();
        if ( getPixelsFileMaps() == null ) {
            return new ome.util.EmptyIterator<ome.model.core.PixelsOriginalFileMap>();
        }
        return getPixelsFileMaps().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.core.PixelsOriginalFileMap> unmodifiablePixelsFileMaps() {
        if (! _loaded ) errorIfUnloaded();
        if ( getPixelsFileMaps() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getPixelsFileMaps() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.core.PixelsOriginalFileMap while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iteratePixelsFileMaps} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectPixelsFileMaps(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.core.PixelsOriginalFileMap> it = iteratePixelsFileMaps();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setPixelsFileMaps . Makes the necessary
     * call on ome.model.core.PixelsOriginalFileMap as well.
     */
    public void addPixelsOriginalFileMap(ome.model.core.PixelsOriginalFileMap target) {
        if (! _loaded ) errorIfUnloaded();
        if (getPixelsFileMaps() == null) {
            throwNullCollectionException("PixelsFileMaps");
        }
        getPixelsFileMaps().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addPixelsOriginalFileMap.
     */
    public void addPixelsOriginalFileMapSet(java.util.Collection<ome.model.core.PixelsOriginalFileMap> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getPixelsFileMaps() == null) {
           throwNullCollectionException("PixelsFileMaps");
        }
        getPixelsFileMaps().addAll( targets );
        java.util.Iterator<ome.model.core.PixelsOriginalFileMap> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.core.PixelsOriginalFileMap target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.core.PixelsOriginalFileMap
     */
    public void removePixelsOriginalFileMap(ome.model.core.PixelsOriginalFileMap target) {
        if (! _loaded ) errorIfUnloaded();
        if (getPixelsFileMaps() == null) {
            throwNullCollectionException("PixelsFileMaps");
        }
        getPixelsFileMaps().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removePixelsOriginalFileMap
     */
    public void removePixelsOriginalFileMapSet(java.util.Collection<ome.model.core.PixelsOriginalFileMap> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getPixelsFileMaps() == null) {
            throwNullCollectionException("PixelsFileMaps");
        }
        getPixelsFileMaps().removeAll( targets );
        java.util.Iterator<ome.model.core.PixelsOriginalFileMap> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.core.PixelsOriginalFileMap target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.core.PixelsOriginalFileMap to pixelsFileMaps . This entails changing our pixelsFileMaps Set,
     * creating a new ome.model.core.PixelsOriginalFileMap and calling linkPixels on the ome.model.core.Pixels.
     */
    public ome.model.core.PixelsOriginalFileMap linkPixels (ome.model.core.Pixels addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.core.PixelsOriginalFileMap link = new ome.model.core.PixelsOriginalFileMap();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addPixelsOriginalFileMap( link, true );
        return link;
    }

    /**
     * Adds a ome.model.core.PixelsOriginalFileMap to pixelsFileMaps, allowing for recursion -- whether
     * or not addPixelsOriginalFileMap will be called on the addition <b>if it is loaded</b>
     */
    public void addPixelsOriginalFileMap (ome.model.core.PixelsOriginalFileMap link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getPixelsFileMaps() == null ) {
            throwNullCollectionException("PixelsFileMaps");
        }
        getPixelsFileMaps().add( link );

        if ( bothSides && link.child().isLoaded() ) {
            link.child().addPixelsOriginalFileMap( link, false );
        }
    }

    /**
     * provides an iterator over the parent values of the pixelsFileMaps. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedPixelsList()} instead.
     */
     public java.util.Iterator<ome.model.core.Pixels> linkedPixelsIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getPixelsFileMaps() == null ) {
            return new ome.util.EmptyIterator<ome.model.core.Pixels>();
        }

        final java.util.Iterator<ome.model.core.PixelsOriginalFileMap> it = getPixelsFileMaps().iterator();
        return new java.util.Iterator<ome.model.core.Pixels>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.core.Pixels next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "pixelsFileMaps is null; no elements." );
                }
                ome.model.core.PixelsOriginalFileMap link = (ome.model.core.PixelsOriginalFileMap) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.core.PixelsOriginalFileMap which have the argument as their child.
     */
    public java.util.Set<ome.model.core.PixelsOriginalFileMap> findPixelsOriginalFileMap( ome.model.core.Pixels target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.core.PixelsOriginalFileMap> it = iteratePixelsFileMaps();
        final java.util.Set<ome.model.core.PixelsOriginalFileMap> result = new java.util.HashSet<ome.model.core.PixelsOriginalFileMap>();
        while ( it.hasNext() ) {
            ome.model.core.PixelsOriginalFileMap link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedPixelsIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.core.Pixels> linkedPixelsList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.core.Pixels> it = linkedPixelsIterator();
        java.util.List<ome.model.core.Pixels> list = new java.util.ArrayList<ome.model.core.Pixels>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.core.Pixels while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedPixels(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.core.Pixels> it = linkedPixelsIterator();
        while ( it.hasNext() ) {
            ome.model.core.Pixels obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.core.Pixels instances from this instance.
     */
    public void unlinkPixels (ome.model.core.Pixels removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.core.PixelsOriginalFileMap> toRemove = findPixelsOriginalFileMap( removal );
        java.util.Iterator<ome.model.core.PixelsOriginalFileMap> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removePixelsOriginalFileMap( it.next(), true );
        }
    }

    /**
     * removes the given PixelsOriginalFileMap from pixelsFileMaps, allowing for recursion -- whether
     * or not the removal will call unlinkOriginalFile again <b>if loaded</b>.
     */
    public void removePixelsOriginalFileMap (ome.model.core.PixelsOriginalFileMap link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getPixelsFileMaps() == null ) {
            throwNullCollectionException("PixelsFileMaps");
        }

        getPixelsFileMaps().remove( link );

        if ( bothSides && link.child().isLoaded() ) {
            link.child().removePixelsOriginalFileMap( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearPixelsLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.core.PixelsOriginalFileMap> list = new java.util.ArrayList<ome.model.core.PixelsOriginalFileMap>( getPixelsFileMaps() );
        for (ome.model.core.PixelsOriginalFileMap link : list) {
            removePixelsOriginalFileMap( link, true );
        }
    }

    private java.util.Map<Long, Long> pixelsFileMapsCountPerOwner = null;

    protected void setPixelsFileMapsCountPerOwner(java.util.Map<Long, Long> map) {
        this.pixelsFileMapsCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_OriginalFile_pixelsFileMaps_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.core.PixelsOriginalFileMap that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_OriginalFile_pixelsFileMaps") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_OriginalFile_pixelsFileMaps_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="OriginalFile_id"))
    public java.util.Map<Long, Long> getPixelsFileMapsCountPerOwner() {
        return this.pixelsFileMapsCountPerOwner;
    }

    protected java.lang.String path = null;

   /**
    * Simple field ome.model.core.OriginalFile.path (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="path", updatable=true)
    public java.lang.String getPath() {
        if (! _loaded ) errorIfUnloaded();
        return this.path;
    }

    public void setPath(java.lang.String path) {
        if (! _loaded ) errorIfUnloaded();
        this.path = (java.lang.String) path;
    }
    protected java.lang.String repo = null;

   /**
    * Simple field ome.model.core.OriginalFile.repo (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="repo", updatable=true)
    public java.lang.String getRepo() {
        if (! _loaded ) errorIfUnloaded();
        return this.repo;
    }

    public void setRepo(java.lang.String repo) {
        if (! _loaded ) errorIfUnloaded();
        this.repo = (java.lang.String) repo;
    }
    protected java.lang.Long size = null;

   /**
    * Simple field ome.model.core.OriginalFile.size (java.lang.Long) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="\"size\"", updatable=true)
    public java.lang.Long getSize() {
        if (! _loaded ) errorIfUnloaded();
        return this.size;
    }

    public void setSize(java.lang.Long size) {
        if (! _loaded ) errorIfUnloaded();
        this.size = (java.lang.Long) size;
    }
    protected java.sql.Timestamp atime = null;

   /**
    * Simple field ome.model.core.OriginalFile.atime (java.sql.Timestamp) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.DateBridge(
        resolution=org.hibernate.search.annotations.Resolution.MINUTE)
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name = "combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="atime", updatable=true)
    public java.sql.Timestamp getAtime() {
        if (! _loaded ) errorIfUnloaded();
        return this.atime;
    }

    public void setAtime(java.sql.Timestamp atime) {
        if (! _loaded ) errorIfUnloaded();
        this.atime = (java.sql.Timestamp) atime;
    }
    protected java.sql.Timestamp mtime = null;

   /**
    * Simple field ome.model.core.OriginalFile.mtime (java.sql.Timestamp) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.DateBridge(
        resolution=org.hibernate.search.annotations.Resolution.MINUTE)
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name = "combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="mtime", updatable=true)
    public java.sql.Timestamp getMtime() {
        if (! _loaded ) errorIfUnloaded();
        return this.mtime;
    }

    public void setMtime(java.sql.Timestamp mtime) {
        if (! _loaded ) errorIfUnloaded();
        this.mtime = (java.sql.Timestamp) mtime;
    }
    protected java.sql.Timestamp ctime = null;

   /**
    * Simple field ome.model.core.OriginalFile.ctime (java.sql.Timestamp) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.DateBridge(
        resolution=org.hibernate.search.annotations.Resolution.MINUTE)
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name = "combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="ctime", updatable=true)
    public java.sql.Timestamp getCtime() {
        if (! _loaded ) errorIfUnloaded();
        return this.ctime;
    }

    public void setCtime(java.sql.Timestamp ctime) {
        if (! _loaded ) errorIfUnloaded();
        this.ctime = (java.sql.Timestamp) ctime;
    }
    protected ome.model.enums.ChecksumAlgorithm hasher = null;

   /**
    * Many-to-one field ome.model.core.OriginalFile.hasher (ome.model.enums.ChecksumAlgorithm)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.ChecksumAlgorithm.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="hasher", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKoriginalfile_hasher_checksumalgorithm")
    public ome.model.enums.ChecksumAlgorithm getHasher() {
        if (! _loaded ) errorIfUnloaded();
        return this.hasher;
    }

    public void setHasher(ome.model.enums.ChecksumAlgorithm hasher) {
        if (! _loaded ) errorIfUnloaded();
        this.hasher = hasher;
    }
    protected java.lang.String hash = null;

   /**
    * Simple field ome.model.core.OriginalFile.hash (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="hash", updatable=true)
    public java.lang.String getHash() {
        if (! _loaded ) errorIfUnloaded();
        return this.hash;
    }

    public void setHash(java.lang.String hash) {
        if (! _loaded ) errorIfUnloaded();
        this.hash = (java.lang.String) hash;
    }
    protected java.lang.String mimetype = null;

   /**
    * Simple field ome.model.core.OriginalFile.mimetype (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="mimetype", updatable=true)
    public java.lang.String getMimetype() {
        if (! _loaded ) errorIfUnloaded();
        return this.mimetype;
    }

    public void setMimetype(java.lang.String mimetype) {
        if (! _loaded ) errorIfUnloaded();
        this.mimetype = (java.lang.String) mimetype;
    }
    protected java.util.Set<ome.model.fs.FilesetEntry> filesetEntries = new java.util.HashSet<ome.model.fs.FilesetEntry>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_FILESETENTRIES = "originalfile_owner_filter_FILESETENTRIES";
    public final static String GROUP_FILTER_FILESETENTRIES = "originalfile_group_filter_FILESETENTRIES";
    public final static String EVENT_FILTER_FILESETENTRIES = "originalfile_event_filter_FILESETENTRIES";
    public final static String PERMS_FILTER_FILESETENTRIES = "originalfile_perms_filter_FILESETENTRIES";

   /**
    * returns filesetEntries . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.core.OriginalFile.filesetEntries (ome.model.fs.FilesetEntry)
    */
    @javax.persistence.OneToMany(mappedBy="originalFile", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_FILESETENTRIES, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_FILESETENTRIES, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_FILESETENTRIES, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_FILESETENTRIES, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.fs.FilesetEntry> getFilesetEntries() {
        if (! _loaded ) errorIfUnloaded();
        return this.filesetEntries;
    }

    /**
     * setter for filesetEntries should be avoided. Does not fulfill normal semantics.
     */
    protected void setFilesetEntries(java.util.Set<ome.model.fs.FilesetEntry> filesetEntries) {
        if (! _loaded ) errorIfUnloaded();
        this.filesetEntries = filesetEntries;
    }
    /**
     * returns the size of filesetEntries. If less than zero, the Set was null.
     */
    public int sizeOfFilesetEntries() {
        if (! _loaded ) errorIfUnloaded();
        return this.filesetEntries == null ? -1 : this.filesetEntries.size();
    }

    /**
     * should be used rather than accessing the filesetEntries set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfFilesetEntries()} is less than zero.
     */
    public java.util.Iterator<ome.model.fs.FilesetEntry> iterateFilesetEntries() {
        if (! _loaded ) errorIfUnloaded();
        if ( getFilesetEntries() == null ) {
            return new ome.util.EmptyIterator<ome.model.fs.FilesetEntry>();
        }
        return getFilesetEntries().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.fs.FilesetEntry> unmodifiableFilesetEntries() {
        if (! _loaded ) errorIfUnloaded();
        if ( getFilesetEntries() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getFilesetEntries() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.fs.FilesetEntry while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateFilesetEntries} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectFilesetEntries(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.fs.FilesetEntry> it = iterateFilesetEntries();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setFilesetEntries . Makes the necessary
     * call on ome.model.fs.FilesetEntry as well.
     */
    public void addFilesetEntry(ome.model.fs.FilesetEntry target) {
        if (! _loaded ) errorIfUnloaded();
        if (getFilesetEntries() == null) {
            throwNullCollectionException("FilesetEntries");
        }
        getFilesetEntries().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setOriginalFile ( this );
         }
    }

    /**
     * use like addFilesetEntry.
     */
    public void addFilesetEntrySet(java.util.Collection<ome.model.fs.FilesetEntry> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getFilesetEntries() == null) {
           throwNullCollectionException("FilesetEntries");
        }
        getFilesetEntries().addAll( targets );
        java.util.Iterator<ome.model.fs.FilesetEntry> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.fs.FilesetEntry target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setOriginalFile ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.fs.FilesetEntry
     */
    public void removeFilesetEntry(ome.model.fs.FilesetEntry target) {
        if (! _loaded ) errorIfUnloaded();
        if (getFilesetEntries() == null) {
            throwNullCollectionException("FilesetEntries");
        }
        getFilesetEntries().remove( target );
            target.setOriginalFile ( null );
    }

    /**
     * use like removeFilesetEntry
     */
    public void removeFilesetEntrySet(java.util.Collection<ome.model.fs.FilesetEntry> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getFilesetEntries() == null) {
            throwNullCollectionException("FilesetEntries");
        }
        getFilesetEntries().removeAll( targets );
        java.util.Iterator<ome.model.fs.FilesetEntry> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.fs.FilesetEntry target = it.next();
                target.setOriginalFile ( null );
        }
    }

    /**
     * clears the set.
     */
    public void clearFilesetEntries() {
        if (! _loaded ) errorIfUnloaded();
        if (getFilesetEntries() == null) {
            throwNullCollectionException("FilesetEntries");
        }
        getFilesetEntries().clear();
        java.util.Iterator<ome.model.fs.FilesetEntry> it = iterateFilesetEntries();
        while (it.hasNext()) {
            ome.model.fs.FilesetEntry target = it.next();
            target.setOriginalFile ( null );
        }
    }


    protected java.util.Set<ome.model.annotations.OriginalFileAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.OriginalFileAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "originalfile_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "originalfile_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "originalfile_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "originalfile_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.core.OriginalFile.annotationLinks (ome.model.annotations.OriginalFileAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.OriginalFileAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.OriginalFileAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.OriginalFileAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.OriginalFileAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.annotations.OriginalFileAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.OriginalFileAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.OriginalFileAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.OriginalFileAnnotationLink as well.
     */
    public void addOriginalFileAnnotationLink(ome.model.annotations.OriginalFileAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addOriginalFileAnnotationLink.
     */
    public void addOriginalFileAnnotationLinkSet(java.util.Collection<ome.model.annotations.OriginalFileAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.OriginalFileAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.OriginalFileAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.OriginalFileAnnotationLink
     */
    public void removeOriginalFileAnnotationLink(ome.model.annotations.OriginalFileAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeOriginalFileAnnotationLink
     */
    public void removeOriginalFileAnnotationLinkSet(java.util.Collection<ome.model.annotations.OriginalFileAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.OriginalFileAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.OriginalFileAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.OriginalFileAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.OriginalFileAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.OriginalFileAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.OriginalFileAnnotationLink link = new ome.model.annotations.OriginalFileAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addOriginalFileAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.OriginalFileAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addOriginalFileAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addOriginalFileAnnotationLink (ome.model.annotations.OriginalFileAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.OriginalFileAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.OriginalFileAnnotationLink link = (ome.model.annotations.OriginalFileAnnotationLink) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.OriginalFileAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.OriginalFileAnnotationLink> findOriginalFileAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.OriginalFileAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.OriginalFileAnnotationLink> result = new java.util.HashSet<ome.model.annotations.OriginalFileAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.OriginalFileAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.OriginalFileAnnotationLink> toRemove = findOriginalFileAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.OriginalFileAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeOriginalFileAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given OriginalFileAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkOriginalFile again <b>if loaded</b>.
     */
    public void removeOriginalFileAnnotationLink (ome.model.annotations.OriginalFileAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.OriginalFileAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.OriginalFileAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.OriginalFileAnnotationLink link : list) {
            removeOriginalFileAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_OriginalFile_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.OriginalFileAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_OriginalFile_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_OriginalFile_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="OriginalFile_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected java.lang.String name = null;

   /**
    * Simple field ome.model.core.OriginalFile.name (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="name", updatable=true)
    public java.lang.String getName() {
        if (! _loaded ) errorIfUnloaded();
        return this.name;
    }

    public void setName(java.lang.String name) {
        if (! _loaded ) errorIfUnloaded();
        this.name = (java.lang.String) name;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.core.OriginalFile newInstance()
    {
        return new ome.model.core.OriginalFile();
    }

    public ome.model.core.OriginalFile proxy() {
        return new ome.model.core.OriginalFile(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.pixelsFileMapsCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(PIXELSFILEMAPSCOUNTPEROWNER, this.pixelsFileMapsCountPerOwner );
            this.pixelsFileMaps = (java.util.Set<ome.model.core.PixelsOriginalFileMap>) __filter.filter(PIXELSFILEMAPS, this.pixelsFileMaps );
            this.path = (java.lang.String) __filter.filter(PATH, this.path );
            this.repo = (java.lang.String) __filter.filter(REPO, this.repo );
            this.size = (java.lang.Long) __filter.filter(SIZE, this.size );
            this.atime = (java.sql.Timestamp) __filter.filter(ATIME, this.atime );
            this.mtime = (java.sql.Timestamp) __filter.filter(MTIME, this.mtime );
            this.ctime = (java.sql.Timestamp) __filter.filter(CTIME, this.ctime );
            this.hasher = (ome.model.enums.ChecksumAlgorithm) __filter.filter(HASHER, this.hasher );
            this.hash = (java.lang.String) __filter.filter(HASH, this.hash );
            this.mimetype = (java.lang.String) __filter.filter(MIMETYPE, this.mimetype );
            this.filesetEntries = (java.util.Set<ome.model.fs.FilesetEntry>) __filter.filter(FILESETENTRIES, this.filesetEntries );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.OriginalFileAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.name = (java.lang.String) __filter.filter(NAME, this.name );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.core.OriginalFile.FIELDS;
    }

    public final static String PIXELSFILEMAPSCOUNTPEROWNER = "ome.model.core.OriginalFile_pixelsFileMapsCountPerOwner";
    public final static String PIXELSFILEMAPS = "ome.model.core.OriginalFile_pixelsFileMaps";
    public final static String PATH = "ome.model.core.OriginalFile_path";
    public final static String REPO = "ome.model.core.OriginalFile_repo";
    public final static String SIZE = "ome.model.core.OriginalFile_size";
    public final static String ATIME = "ome.model.core.OriginalFile_atime";
    public final static String MTIME = "ome.model.core.OriginalFile_mtime";
    public final static String CTIME = "ome.model.core.OriginalFile_ctime";
    public final static String HASHER = "ome.model.core.OriginalFile_hasher";
    public final static String HASH = "ome.model.core.OriginalFile_hash";
    public final static String MIMETYPE = "ome.model.core.OriginalFile_mimetype";
    public final static String FILESETENTRIES = "ome.model.core.OriginalFile_filesetEntries";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.core.OriginalFile_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.core.OriginalFile_annotationLinks";
    public final static String NAME = "ome.model.core.OriginalFile_name";
    public final static String DETAILS = "ome.model.core.OriginalFile_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(PIXELSFILEMAPSCOUNTPEROWNER);
       raw.add(PIXELSFILEMAPS);
       raw.add(PATH);
       raw.add(REPO);
       raw.add(SIZE);
       raw.add(ATIME);
       raw.add(MTIME);
       raw.add(CTIME);
       raw.add(HASHER);
       raw.add(HASH);
       raw.add(MIMETYPE);
       raw.add(FILESETENTRIES);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(NAME);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(PIXELSFILEMAPSCOUNTPEROWNER)) {
            return getPixelsFileMapsCountPerOwner();
        } else if (field.equals(PIXELSFILEMAPS)) {
            return getPixelsFileMaps();
        } else if (field.equals(PATH)) {
            return getPath();
        } else if (field.equals(REPO)) {
            return getRepo();
        } else if (field.equals(SIZE)) {
            return getSize();
        } else if (field.equals(ATIME)) {
            return getAtime();
        } else if (field.equals(MTIME)) {
            return getMtime();
        } else if (field.equals(CTIME)) {
            return getCtime();
        } else if (field.equals(HASHER)) {
            return getHasher();
        } else if (field.equals(HASH)) {
            return getHash();
        } else if (field.equals(MIMETYPE)) {
            return getMimetype();
        } else if (field.equals(FILESETENTRIES)) {
            return getFilesetEntries();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) {
            return getAnnotationLinks();
        } else if (field.equals(NAME)) {
            return getName();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(PIXELSFILEMAPSCOUNTPEROWNER)) {
            setPixelsFileMapsCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(PIXELSFILEMAPS)) {
            setPixelsFileMaps((java.util.Set<ome.model.core.PixelsOriginalFileMap>)value);
        } else if (field.equals(PATH)) {
            setPath((java.lang.String)value);
        } else if (field.equals(REPO)) {
            setRepo((java.lang.String)value);
        } else if (field.equals(SIZE)) {
            setSize((java.lang.Long)value);
        } else if (field.equals(ATIME)) {
            setAtime((java.sql.Timestamp)value);
        } else if (field.equals(MTIME)) {
            setMtime((java.sql.Timestamp)value);
        } else if (field.equals(CTIME)) {
            setCtime((java.sql.Timestamp)value);
        } else if (field.equals(HASHER)) {
            setHasher((ome.model.enums.ChecksumAlgorithm)value);
        } else if (field.equals(HASH)) {
            setHash((java.lang.String)value);
        } else if (field.equals(MIMETYPE)) {
            setMimetype((java.lang.String)value);
        } else if (field.equals(FILESETENTRIES)) {
            setFilesetEntries((java.util.Set<ome.model.fs.FilesetEntry>)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.OriginalFileAnnotationLink>)value);
        } else if (field.equals(NAME)) {
            setName((java.lang.String)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.pixelsFileMapsCountPerOwner = null;
        this.pixelsFileMaps = null;
        this.path = null;
        this.repo = null;
        this.size = null;
        this.atime = null;
        this.mtime = null;
        this.ctime = null;
        this.hasher = null;
        this.hash = null;
        this.mimetype = null;
        this.filesetEntries = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.name = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKoriginalfile_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKoriginalfile_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKoriginalfile_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKoriginalfile_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKoriginalfile_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
