

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.core;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="planeinfo_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="planeinfo_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="planeinfo_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="planeinfo_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="planeinfo_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="planeinfo_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="planeinfo_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="planeinfo_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="planeinfo_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="planeinfo_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="planeinfo_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="planeinfo_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
        "id IN (SELECT planeinfo.id FROM planeinfo*, pixels* WHERE " +
        "planeinfo.pixels = pixels.id AND pixels.image IN (:images)))")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "planeinfo", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_planeinfo",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_planeinfo"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class PlaneInfo
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "planeinfo_owner_filter";
    public final static String GROUP_FILTER = "planeinfo_group_filter";
    public final static String EVENT_FILTER = "planeinfo_event_filter";
    public final static String PERMS_FILTER = "planeinfo_perms_filter";

    public PlaneInfo () {
        this(null, true);
    }

    protected PlaneInfo (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public PlaneInfo (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public PlaneInfo(
ome.model.core.Pixels _pixels,java.lang.Integer _theZ,java.lang.Integer _theC,java.lang.Integer _theT    ) {
        this(null, true);
        setPixels(_pixels);
        setTheZ(_theZ);
        setTheC(_theC);
        setTheT(_theT);
    }

    public final static String ID = "ome.model.core.PlaneInfo_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_planeinfo") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.core.PlaneInfo_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected ome.model.core.Pixels pixels = null;

   /**
    * Many-to-one field ome.model.core.PlaneInfo.pixels (ome.model.core.Pixels)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.core.Pixels.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="pixels", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKplaneinfo_pixels_pixels")
    public ome.model.core.Pixels getPixels() {
        if (! _loaded ) errorIfUnloaded();
        return this.pixels;
    }

    public void setPixels(ome.model.core.Pixels pixels) {
        if (! _loaded ) errorIfUnloaded();
        this.pixels = pixels;
    }
    protected java.lang.Integer theZ = null;

   /**
    * Simple field ome.model.core.PlaneInfo.theZ (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="nonnegative_int", nullable=false, unique=false, name="theZ", updatable=true)
    public java.lang.Integer getTheZ() {
        if (! _loaded ) errorIfUnloaded();
        return this.theZ;
    }

    public void setTheZ(java.lang.Integer theZ) {
        if (! _loaded ) errorIfUnloaded();
        if (theZ != null && theZ < 0) {
            throw new IllegalArgumentException("values of PlaneInfo.theZ must not be negative");
        }
        this.theZ = (java.lang.Integer) theZ;
    }
    protected java.lang.Integer theC = null;

   /**
    * Simple field ome.model.core.PlaneInfo.theC (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="nonnegative_int", nullable=false, unique=false, name="theC", updatable=true)
    public java.lang.Integer getTheC() {
        if (! _loaded ) errorIfUnloaded();
        return this.theC;
    }

    public void setTheC(java.lang.Integer theC) {
        if (! _loaded ) errorIfUnloaded();
        if (theC != null && theC < 0) {
            throw new IllegalArgumentException("values of PlaneInfo.theC must not be negative");
        }
        this.theC = (java.lang.Integer) theC;
    }
    protected java.lang.Integer theT = null;

   /**
    * Simple field ome.model.core.PlaneInfo.theT (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="nonnegative_int", nullable=false, unique=false, name="theT", updatable=true)
    public java.lang.Integer getTheT() {
        if (! _loaded ) errorIfUnloaded();
        return this.theT;
    }

    public void setTheT(java.lang.Integer theT) {
        if (! _loaded ) errorIfUnloaded();
        if (theT != null && theT < 0) {
            throw new IllegalArgumentException("values of PlaneInfo.theT must not be negative");
        }
        this.theT = (java.lang.Integer) theT;
    }
    protected ome.model.units.Time deltaT = null;

 
   /**
    * Enum-mapped unit-based field ome.model.core.PlaneInfo.deltaT (ome.model.units.Time)
    */
    @javax.persistence.Embedded
     @javax.persistence.AttributeOverrides( {
            @javax.persistence.AttributeOverride(name="value", column = @javax.persistence.Column(name="deltaT") ),
            @javax.persistence.AttributeOverride(name="unit", column = @javax.persistence.Column(name="deltaTUnit") )
    } )
    public ome.model.units.Time getDeltaT() {
        if (! _loaded ) errorIfUnloaded();
        return this.deltaT;
    }

    public void setDeltaT(ome.model.units.Time deltaT) {
        if (! _loaded ) errorIfUnloaded();
        this.deltaT = deltaT;
    }

    protected ome.model.units.Length positionX = null;

 
   /**
    * Enum-mapped unit-based field ome.model.core.PlaneInfo.positionX (ome.model.units.Length)
    */
    @javax.persistence.Embedded
     @javax.persistence.AttributeOverrides( {
            @javax.persistence.AttributeOverride(name="value", column = @javax.persistence.Column(name="positionX") ),
            @javax.persistence.AttributeOverride(name="unit", column = @javax.persistence.Column(name="positionXUnit") )
    } )
    public ome.model.units.Length getPositionX() {
        if (! _loaded ) errorIfUnloaded();
        return this.positionX;
    }

    public void setPositionX(ome.model.units.Length positionX) {
        if (! _loaded ) errorIfUnloaded();
        this.positionX = positionX;
    }

    protected ome.model.units.Length positionY = null;

 
   /**
    * Enum-mapped unit-based field ome.model.core.PlaneInfo.positionY (ome.model.units.Length)
    */
    @javax.persistence.Embedded
     @javax.persistence.AttributeOverrides( {
            @javax.persistence.AttributeOverride(name="value", column = @javax.persistence.Column(name="positionY") ),
            @javax.persistence.AttributeOverride(name="unit", column = @javax.persistence.Column(name="positionYUnit") )
    } )
    public ome.model.units.Length getPositionY() {
        if (! _loaded ) errorIfUnloaded();
        return this.positionY;
    }

    public void setPositionY(ome.model.units.Length positionY) {
        if (! _loaded ) errorIfUnloaded();
        this.positionY = positionY;
    }

    protected ome.model.units.Length positionZ = null;

 
   /**
    * Enum-mapped unit-based field ome.model.core.PlaneInfo.positionZ (ome.model.units.Length)
    */
    @javax.persistence.Embedded
     @javax.persistence.AttributeOverrides( {
            @javax.persistence.AttributeOverride(name="value", column = @javax.persistence.Column(name="positionZ") ),
            @javax.persistence.AttributeOverride(name="unit", column = @javax.persistence.Column(name="positionZUnit") )
    } )
    public ome.model.units.Length getPositionZ() {
        if (! _loaded ) errorIfUnloaded();
        return this.positionZ;
    }

    public void setPositionZ(ome.model.units.Length positionZ) {
        if (! _loaded ) errorIfUnloaded();
        this.positionZ = positionZ;
    }

    protected ome.model.units.Time exposureTime = null;

 
   /**
    * Enum-mapped unit-based field ome.model.core.PlaneInfo.exposureTime (ome.model.units.Time)
    */
    @javax.persistence.Embedded
     @javax.persistence.AttributeOverrides( {
            @javax.persistence.AttributeOverride(name="value", column = @javax.persistence.Column(name="exposureTime") ),
            @javax.persistence.AttributeOverride(name="unit", column = @javax.persistence.Column(name="exposureTimeUnit") )
    } )
    public ome.model.units.Time getExposureTime() {
        if (! _loaded ) errorIfUnloaded();
        return this.exposureTime;
    }

    public void setExposureTime(ome.model.units.Time exposureTime) {
        if (! _loaded ) errorIfUnloaded();
        this.exposureTime = exposureTime;
    }

    protected java.util.Set<ome.model.annotations.PlaneInfoAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.PlaneInfoAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "planeinfo_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "planeinfo_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "planeinfo_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "planeinfo_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.core.PlaneInfo.annotationLinks (ome.model.annotations.PlaneInfoAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.PlaneInfoAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.PlaneInfoAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.PlaneInfoAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.PlaneInfoAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.annotations.PlaneInfoAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.PlaneInfoAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.PlaneInfoAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.PlaneInfoAnnotationLink as well.
     */
    public void addPlaneInfoAnnotationLink(ome.model.annotations.PlaneInfoAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addPlaneInfoAnnotationLink.
     */
    public void addPlaneInfoAnnotationLinkSet(java.util.Collection<ome.model.annotations.PlaneInfoAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.PlaneInfoAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.PlaneInfoAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.PlaneInfoAnnotationLink
     */
    public void removePlaneInfoAnnotationLink(ome.model.annotations.PlaneInfoAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removePlaneInfoAnnotationLink
     */
    public void removePlaneInfoAnnotationLinkSet(java.util.Collection<ome.model.annotations.PlaneInfoAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.PlaneInfoAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.PlaneInfoAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.PlaneInfoAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.PlaneInfoAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.PlaneInfoAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.PlaneInfoAnnotationLink link = new ome.model.annotations.PlaneInfoAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addPlaneInfoAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.PlaneInfoAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addPlaneInfoAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addPlaneInfoAnnotationLink (ome.model.annotations.PlaneInfoAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.PlaneInfoAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.PlaneInfoAnnotationLink link = (ome.model.annotations.PlaneInfoAnnotationLink) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.PlaneInfoAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.PlaneInfoAnnotationLink> findPlaneInfoAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.PlaneInfoAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.PlaneInfoAnnotationLink> result = new java.util.HashSet<ome.model.annotations.PlaneInfoAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.PlaneInfoAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.PlaneInfoAnnotationLink> toRemove = findPlaneInfoAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.PlaneInfoAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removePlaneInfoAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given PlaneInfoAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkPlaneInfo again <b>if loaded</b>.
     */
    public void removePlaneInfoAnnotationLink (ome.model.annotations.PlaneInfoAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.PlaneInfoAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.PlaneInfoAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.PlaneInfoAnnotationLink link : list) {
            removePlaneInfoAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_PlaneInfo_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.PlaneInfoAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_PlaneInfo_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_PlaneInfo_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="PlaneInfo_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.core.PlaneInfo newInstance()
    {
        return new ome.model.core.PlaneInfo();
    }

    public ome.model.core.PlaneInfo proxy() {
        return new ome.model.core.PlaneInfo(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.pixels = (ome.model.core.Pixels) __filter.filter(PIXELS, this.pixels );
            this.theZ = (java.lang.Integer) __filter.filter(THEZ, this.theZ );
            this.theC = (java.lang.Integer) __filter.filter(THEC, this.theC );
            this.theT = (java.lang.Integer) __filter.filter(THET, this.theT );
            this.deltaT = (ome.model.units.Time) __filter.filter(DELTAT, this.deltaT );
            this.positionX = (ome.model.units.Length) __filter.filter(POSITIONX, this.positionX );
            this.positionY = (ome.model.units.Length) __filter.filter(POSITIONY, this.positionY );
            this.positionZ = (ome.model.units.Length) __filter.filter(POSITIONZ, this.positionZ );
            this.exposureTime = (ome.model.units.Time) __filter.filter(EXPOSURETIME, this.exposureTime );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.PlaneInfoAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.core.PlaneInfo.FIELDS;
    }

    public final static String PIXELS = "ome.model.core.PlaneInfo_pixels";
    public final static String THEZ = "ome.model.core.PlaneInfo_theZ";
    public final static String THEC = "ome.model.core.PlaneInfo_theC";
    public final static String THET = "ome.model.core.PlaneInfo_theT";
    public final static String DELTAT = "ome.model.core.PlaneInfo_deltaT";
    public final static String POSITIONX = "ome.model.core.PlaneInfo_positionX";
    public final static String POSITIONY = "ome.model.core.PlaneInfo_positionY";
    public final static String POSITIONZ = "ome.model.core.PlaneInfo_positionZ";
    public final static String EXPOSURETIME = "ome.model.core.PlaneInfo_exposureTime";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.core.PlaneInfo_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.core.PlaneInfo_annotationLinks";
    public final static String DETAILS = "ome.model.core.PlaneInfo_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(PIXELS);
       raw.add(THEZ);
       raw.add(THEC);
       raw.add(THET);
       raw.add(DELTAT);
       raw.add(POSITIONX);
       raw.add(POSITIONY);
       raw.add(POSITIONZ);
       raw.add(EXPOSURETIME);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(PIXELS)) {
            return getPixels();
        } else if (field.equals(THEZ)) {
            return getTheZ();
        } else if (field.equals(THEC)) {
            return getTheC();
        } else if (field.equals(THET)) {
            return getTheT();
        } else if (field.equals(DELTAT)) {
            return getDeltaT();
        } else if (field.equals(POSITIONX)) {
            return getPositionX();
        } else if (field.equals(POSITIONY)) {
            return getPositionY();
        } else if (field.equals(POSITIONZ)) {
            return getPositionZ();
        } else if (field.equals(EXPOSURETIME)) {
            return getExposureTime();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) {
            return getAnnotationLinks();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(PIXELS)) {
            setPixels((ome.model.core.Pixels)value);
        } else if (field.equals(THEZ)) {
            setTheZ((java.lang.Integer)value);
        } else if (field.equals(THEC)) {
            setTheC((java.lang.Integer)value);
        } else if (field.equals(THET)) {
            setTheT((java.lang.Integer)value);
        } else if (field.equals(DELTAT)) {
            setDeltaT((ome.model.units.Time)value);
        } else if (field.equals(POSITIONX)) {
            setPositionX((ome.model.units.Length)value);
        } else if (field.equals(POSITIONY)) {
            setPositionY((ome.model.units.Length)value);
        } else if (field.equals(POSITIONZ)) {
            setPositionZ((ome.model.units.Length)value);
        } else if (field.equals(EXPOSURETIME)) {
            setExposureTime((ome.model.units.Time)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.PlaneInfoAnnotationLink>)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.pixels = null;
        this.theZ = null;
        this.theC = null;
        this.theT = null;
        this.deltaT = null;
        this.positionX = null;
        this.positionY = null;
        this.positionZ = null;
        this.exposureTime = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKplaneinfo_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKplaneinfo_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKplaneinfo_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKplaneinfo_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKplaneinfo_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
