

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.display;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="channelbinding_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="channelbinding_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="channelbinding_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="channelbinding_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="channelbinding_owner_filter_SPATIALDOMAINENHANCEMENT",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="channelbinding_group_filter_SPATIALDOMAINENHANCEMENT",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="channelbinding_event_filter_SPATIALDOMAINENHANCEMENT",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="channelbinding_perms_filter_SPATIALDOMAINENHANCEMENT",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="channelbinding_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="channelbinding_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="channelbinding_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="channelbinding_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
        "id IN (SELECT channelbinding.id FROM channelbinding*, renderingdef*, pixels* WHERE " +
        "channelbinding.renderingdef = renderingdef.id AND renderingdef.pixels = pixels.id AND pixels.image IN (:images)))")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "channelbinding", uniqueConstraints = {
     @javax.persistence.UniqueConstraint(columnNames={"renderingDef","renderingDef_index"})
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_channelbinding",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_channelbinding"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class ChannelBinding
implements java.io.Serializable, IObject
, IMutable{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "channelbinding_owner_filter";
    public final static String GROUP_FILTER = "channelbinding_group_filter";
    public final static String EVENT_FILTER = "channelbinding_event_filter";
    public final static String PERMS_FILTER = "channelbinding_perms_filter";

    public ChannelBinding () {
        this(null, true);
    }

    protected ChannelBinding (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public ChannelBinding (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public ChannelBinding(
ome.model.display.RenderingDef _renderingDef,ome.model.enums.Family _family,java.lang.Double _coefficient,java.lang.Double _inputStart,java.lang.Double _inputEnd,java.lang.Boolean _active,java.lang.Boolean _noiseReduction,java.lang.Integer _red,java.lang.Integer _green,java.lang.Integer _blue,java.lang.Integer _alpha    ) {
        this(null, true);
        setRenderingDef(_renderingDef);
        setFamily(_family);
        setCoefficient(_coefficient);
        setInputStart(_inputStart);
        setInputEnd(_inputEnd);
        setActive(_active);
        setNoiseReduction(_noiseReduction);
        setRed(_red);
        setGreen(_green);
        setBlue(_blue);
        setAlpha(_alpha);
    }

    public final static String ID = "ome.model.display.ChannelBinding_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_channelbinding") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.display.ChannelBinding_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected ome.model.display.RenderingDef renderingDef = null;

   /**
    * Many-to-one field ome.model.display.ChannelBinding.renderingDef (ome.model.display.RenderingDef)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.display.RenderingDef.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="renderingDef", nullable=false,
        unique=false, insertable=false, updatable=false)
    @org.hibernate.annotations.ForeignKey(name="FKchannelbinding_renderingDef_renderingdef")
    public ome.model.display.RenderingDef getRenderingDef() {
        if (! _loaded ) errorIfUnloaded();
        return this.renderingDef;
    }

    public void setRenderingDef(ome.model.display.RenderingDef renderingDef) {
        if (! _loaded ) errorIfUnloaded();
        this.renderingDef = renderingDef;
    }
    protected ome.model.enums.Family family = null;

   /**
    * Many-to-one field ome.model.display.ChannelBinding.family (ome.model.enums.Family)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.Family.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="family", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKchannelbinding_family_family")
    public ome.model.enums.Family getFamily() {
        if (! _loaded ) errorIfUnloaded();
        return this.family;
    }

    public void setFamily(ome.model.enums.Family family) {
        if (! _loaded ) errorIfUnloaded();
        this.family = family;
    }
    protected java.lang.Double coefficient = null;

   /**
    * Simple field ome.model.display.ChannelBinding.coefficient (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="coefficient", updatable=true)
    public java.lang.Double getCoefficient() {
        if (! _loaded ) errorIfUnloaded();
        return this.coefficient;
    }

    public void setCoefficient(java.lang.Double coefficient) {
        if (! _loaded ) errorIfUnloaded();
        this.coefficient = (java.lang.Double) coefficient;
    }
    protected java.lang.Double inputStart = null;

   /**
    * Simple field ome.model.display.ChannelBinding.inputStart (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="inputStart", updatable=true)
    public java.lang.Double getInputStart() {
        if (! _loaded ) errorIfUnloaded();
        return this.inputStart;
    }

    public void setInputStart(java.lang.Double inputStart) {
        if (! _loaded ) errorIfUnloaded();
        this.inputStart = (java.lang.Double) inputStart;
    }
    protected java.lang.Double inputEnd = null;

   /**
    * Simple field ome.model.display.ChannelBinding.inputEnd (java.lang.Double) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="inputEnd", updatable=true)
    public java.lang.Double getInputEnd() {
        if (! _loaded ) errorIfUnloaded();
        return this.inputEnd;
    }

    public void setInputEnd(java.lang.Double inputEnd) {
        if (! _loaded ) errorIfUnloaded();
        this.inputEnd = (java.lang.Double) inputEnd;
    }
    protected java.lang.Boolean active = null;

   /**
    * Simple field ome.model.display.ChannelBinding.active (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="active", updatable=true)
    public java.lang.Boolean getActive() {
        if (! _loaded ) errorIfUnloaded();
        return this.active;
    }

    public void setActive(java.lang.Boolean active) {
        if (! _loaded ) errorIfUnloaded();
        this.active = (java.lang.Boolean) active;
    }
    protected java.lang.Boolean noiseReduction = null;

   /**
    * Simple field ome.model.display.ChannelBinding.noiseReduction (java.lang.Boolean) 
    */
    // No @Type annotation
    // Not indexed

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="noiseReduction", updatable=true)
    public java.lang.Boolean getNoiseReduction() {
        if (! _loaded ) errorIfUnloaded();
        return this.noiseReduction;
    }

    public void setNoiseReduction(java.lang.Boolean noiseReduction) {
        if (! _loaded ) errorIfUnloaded();
        this.noiseReduction = (java.lang.Boolean) noiseReduction;
    }
    protected java.lang.Integer red = null;

   /**
    * Simple field ome.model.display.ChannelBinding.red (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="red", updatable=true)
    public java.lang.Integer getRed() {
        if (! _loaded ) errorIfUnloaded();
        return this.red;
    }

    public void setRed(java.lang.Integer red) {
        if (! _loaded ) errorIfUnloaded();
        this.red = (java.lang.Integer) red;
    }
    protected java.lang.Integer green = null;

   /**
    * Simple field ome.model.display.ChannelBinding.green (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="green", updatable=true)
    public java.lang.Integer getGreen() {
        if (! _loaded ) errorIfUnloaded();
        return this.green;
    }

    public void setGreen(java.lang.Integer green) {
        if (! _loaded ) errorIfUnloaded();
        this.green = (java.lang.Integer) green;
    }
    protected java.lang.Integer blue = null;

   /**
    * Simple field ome.model.display.ChannelBinding.blue (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="blue", updatable=true)
    public java.lang.Integer getBlue() {
        if (! _loaded ) errorIfUnloaded();
        return this.blue;
    }

    public void setBlue(java.lang.Integer blue) {
        if (! _loaded ) errorIfUnloaded();
        this.blue = (java.lang.Integer) blue;
    }
    protected java.lang.Integer alpha = null;

   /**
    * Simple field ome.model.display.ChannelBinding.alpha (java.lang.Integer) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="alpha", updatable=true)
    public java.lang.Integer getAlpha() {
        if (! _loaded ) errorIfUnloaded();
        return this.alpha;
    }

    public void setAlpha(java.lang.Integer alpha) {
        if (! _loaded ) errorIfUnloaded();
        this.alpha = (java.lang.Integer) alpha;
    }
    protected java.lang.String lookupTable = null;

   /**
    * Simple field ome.model.display.ChannelBinding.lookupTable (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="lookupTable", updatable=true)
    public java.lang.String getLookupTable() {
        if (! _loaded ) errorIfUnloaded();
        return this.lookupTable;
    }

    public void setLookupTable(java.lang.String lookupTable) {
        if (! _loaded ) errorIfUnloaded();
        this.lookupTable = (java.lang.String) lookupTable;
    }
    protected java.util.List<ome.model.display.CodomainMapContext> spatialDomainEnhancement = new java.util.ArrayList<ome.model.display.CodomainMapContext>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_SPATIALDOMAINENHANCEMENT = "channelbinding_owner_filter_SPATIALDOMAINENHANCEMENT";
    public final static String GROUP_FILTER_SPATIALDOMAINENHANCEMENT = "channelbinding_group_filter_SPATIALDOMAINENHANCEMENT";
    public final static String EVENT_FILTER_SPATIALDOMAINENHANCEMENT = "channelbinding_event_filter_SPATIALDOMAINENHANCEMENT";
    public final static String PERMS_FILTER_SPATIALDOMAINENHANCEMENT = "channelbinding_perms_filter_SPATIALDOMAINENHANCEMENT";

   /**
    * returns spatialDomainEnhancement . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many List ome.model.display.ChannelBinding.spatialDomainEnhancement (ome.model.display.CodomainMapContext)
    * Values are indexed by the column "index" on ome.model.display.CodomainMapContext
    */
    @javax.persistence.JoinColumn(name="channelBinding", nullable=false)
    @javax.persistence.OneToMany(fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.IndexColumn(name="channelBinding_index", nullable=false)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0 OR " +
            "id IN (SELECT codomainmapcontext.id FROM channelbinding*, codomainmapcontext*, renderingdef*, pixels* WHERE " +
            "codomainmapcontext.channelbinding = channelbinding.id AND channelbinding.renderingdef = renderingdef.id AND " +
            "renderingdef.pixels = pixels.id AND pixels.image IN (:images)))"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_SPATIALDOMAINENHANCEMENT, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_SPATIALDOMAINENHANCEMENT, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_SPATIALDOMAINENHANCEMENT, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_SPATIALDOMAINENHANCEMENT, condition=":permsStr = permissions")
    })
    protected java.util.List<ome.model.display.CodomainMapContext> getSpatialDomainEnhancement() {
        if (! _loaded ) errorIfUnloaded();
        return this.spatialDomainEnhancement;
    }

    /**
     * setter for spatialDomainEnhancement should be avoided. Does not fulfill normal semantics.
     */
    protected void setSpatialDomainEnhancement(java.util.List<ome.model.display.CodomainMapContext> spatialDomainEnhancement) {
        if (! _loaded ) errorIfUnloaded();
        this.spatialDomainEnhancement = spatialDomainEnhancement;
    }
    /**
     * returns the size of spatialDomainEnhancement. If less than zero, the Set was null.
     */
    public int sizeOfSpatialDomainEnhancement() {
        if (! _loaded ) errorIfUnloaded();
        return this.spatialDomainEnhancement == null ? -1 : this.spatialDomainEnhancement.size();
    }

    /**
     * should be used rather than accessing the spatialDomainEnhancement set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfSpatialDomainEnhancement()} is less than zero.
     */
    public java.util.Iterator<ome.model.display.CodomainMapContext> iterateSpatialDomainEnhancement() {
        if (! _loaded ) errorIfUnloaded();
        if ( getSpatialDomainEnhancement() == null ) {
            return new ome.util.EmptyIterator<ome.model.display.CodomainMapContext>();
        }
        return getSpatialDomainEnhancement().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.display.CodomainMapContext> unmodifiableSpatialDomainEnhancement() {
        if (! _loaded ) errorIfUnloaded();
        if ( getSpatialDomainEnhancement() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getSpatialDomainEnhancement() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.display.CodomainMapContext while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateSpatialDomainEnhancement} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectSpatialDomainEnhancement(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.display.CodomainMapContext> it = iterateSpatialDomainEnhancement();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setSpatialDomainEnhancement . Makes the necessary
     * call on ome.model.display.CodomainMapContext as well.
     */
    public void addCodomainMapContext(ome.model.display.CodomainMapContext target) {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        getSpatialDomainEnhancement().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
            if (target.isLoaded()) {
                target.setChannelBinding ( this );
             }
         }
    }

    /**
     * use like addCodomainMapContext.
     */
    public void addCodomainMapContextSet(java.util.Collection<ome.model.display.CodomainMapContext> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
           throwNullCollectionException("SpatialDomainEnhancement");
        }
        getSpatialDomainEnhancement().addAll( targets );
        java.util.Iterator<ome.model.display.CodomainMapContext> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.display.CodomainMapContext target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                if (target.isLoaded()) {
                    target.setChannelBinding ( this );
                }
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.display.CodomainMapContext
     */
    public void removeCodomainMapContext(ome.model.display.CodomainMapContext target) {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        getSpatialDomainEnhancement().remove( target );
        if (target.isLoaded()) {
            target.setChannelBinding ( null );
        }
    }

    /**
     * use like removeCodomainMapContext
     */
    public void removeCodomainMapContextSet(java.util.Collection<ome.model.display.CodomainMapContext> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        getSpatialDomainEnhancement().removeAll( targets );
        java.util.Iterator<ome.model.display.CodomainMapContext> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.display.CodomainMapContext target = it.next();
            if (target.isLoaded()) {
                target.setChannelBinding ( null );
            }
        }
    }

    /**
     * clears the set.
     */
    public void clearSpatialDomainEnhancement() {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        getSpatialDomainEnhancement().clear();
        java.util.Iterator<ome.model.display.CodomainMapContext> it = iterateSpatialDomainEnhancement();
        while (it.hasNext()) {
            ome.model.display.CodomainMapContext target = it.next();
            target.setChannelBinding ( null );
        }
    }


    /**
     * Gets the ome.model.display.CodomainMapContext at the given index.
     */
    public ome.model.display.CodomainMapContext getCodomainMapContext(int index)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        return getSpatialDomainEnhancement().get(index);
    }

    /**
     * Sets the ome.model.display.CodomainMapContext at the given index. Adheres to the {@link java.util.List#set(int, Object)}
     * contract. To extend the list, use {@link #addCodomainMapContext(CodomainMapContext)}.
     * @see java.util.List#set(int, Object)
     */
    public ome.model.display.CodomainMapContext setCodomainMapContext(int index, ome.model.display.CodomainMapContext element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }

        ome.model.display.CodomainMapContext old = getSpatialDomainEnhancement().set(index, element);

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (element != null) {
            if (element.isLoaded()) {
                element.setChannelBinding ( this );
            }
        }

        return old;
    }

    /**
     * Gets the first element of spatialDomainEnhancement which can be interpreted as the
     * primary or default element in some situations. If there is not first
     * element, an {@link IndexOutOfBoundsException} is throws. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfSpatialDomainEnhancement()} for more information.
     */
    @javax.persistence.Transient
    public ome.model.display.CodomainMapContext getPrimaryCodomainMapContext()
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        return getSpatialDomainEnhancement().get(0);
    }

    /**
     * Swaps the first element of spatialDomainEnhancement with the first instance of the
     * given element. If the given element is not in the list, an
     * {@link IndexOutOfBoundsException} will be thrown. Returns the swapped
     * element. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfSpatialDomainEnhancement()} for more information.
     */
    public ome.model.display.CodomainMapContext setPrimaryCodomainMapContext(ome.model.display.CodomainMapContext element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getSpatialDomainEnhancement() == null) {
            throwNullCollectionException("SpatialDomainEnhancement");
        }
        java.util.List<ome.model.display.CodomainMapContext> list = getSpatialDomainEnhancement();
        int index = list.indexOf(element);
        ome.model.display.CodomainMapContext old = list.get(0);
        list.set(index, old);
        list.set(0, element);
        return old;
    }
    
    
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.display.ChannelBinding newInstance()
    {
        return new ome.model.display.ChannelBinding();
    }

    public ome.model.display.ChannelBinding proxy() {
        return new ome.model.display.ChannelBinding(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.renderingDef = (ome.model.display.RenderingDef) __filter.filter(RENDERINGDEF, this.renderingDef );
            this.family = (ome.model.enums.Family) __filter.filter(FAMILY, this.family );
            this.coefficient = (java.lang.Double) __filter.filter(COEFFICIENT, this.coefficient );
            this.inputStart = (java.lang.Double) __filter.filter(INPUTSTART, this.inputStart );
            this.inputEnd = (java.lang.Double) __filter.filter(INPUTEND, this.inputEnd );
            this.active = (java.lang.Boolean) __filter.filter(ACTIVE, this.active );
            this.noiseReduction = (java.lang.Boolean) __filter.filter(NOISEREDUCTION, this.noiseReduction );
            this.red = (java.lang.Integer) __filter.filter(RED, this.red );
            this.green = (java.lang.Integer) __filter.filter(GREEN, this.green );
            this.blue = (java.lang.Integer) __filter.filter(BLUE, this.blue );
            this.alpha = (java.lang.Integer) __filter.filter(ALPHA, this.alpha );
            this.lookupTable = (java.lang.String) __filter.filter(LOOKUPTABLE, this.lookupTable );
            this.spatialDomainEnhancement = (java.util.List<ome.model.display.CodomainMapContext>) __filter.filter(SPATIALDOMAINENHANCEMENT, this.spatialDomainEnhancement );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.display.ChannelBinding.FIELDS;
    }

    public final static String RENDERINGDEF = "ome.model.display.ChannelBinding_renderingDef";
    public final static String FAMILY = "ome.model.display.ChannelBinding_family";
    public final static String COEFFICIENT = "ome.model.display.ChannelBinding_coefficient";
    public final static String INPUTSTART = "ome.model.display.ChannelBinding_inputStart";
    public final static String INPUTEND = "ome.model.display.ChannelBinding_inputEnd";
    public final static String ACTIVE = "ome.model.display.ChannelBinding_active";
    public final static String NOISEREDUCTION = "ome.model.display.ChannelBinding_noiseReduction";
    public final static String RED = "ome.model.display.ChannelBinding_red";
    public final static String GREEN = "ome.model.display.ChannelBinding_green";
    public final static String BLUE = "ome.model.display.ChannelBinding_blue";
    public final static String ALPHA = "ome.model.display.ChannelBinding_alpha";
    public final static String LOOKUPTABLE = "ome.model.display.ChannelBinding_lookupTable";
    public final static String SPATIALDOMAINENHANCEMENT = "ome.model.display.ChannelBinding_spatialDomainEnhancement";
    public final static String DETAILS = "ome.model.display.ChannelBinding_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(RENDERINGDEF);
       raw.add(FAMILY);
       raw.add(COEFFICIENT);
       raw.add(INPUTSTART);
       raw.add(INPUTEND);
       raw.add(ACTIVE);
       raw.add(NOISEREDUCTION);
       raw.add(RED);
       raw.add(GREEN);
       raw.add(BLUE);
       raw.add(ALPHA);
       raw.add(LOOKUPTABLE);
       raw.add(SPATIALDOMAINENHANCEMENT);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(RENDERINGDEF)) {
            return getRenderingDef();
        } else if (field.equals(FAMILY)) {
            return getFamily();
        } else if (field.equals(COEFFICIENT)) {
            return getCoefficient();
        } else if (field.equals(INPUTSTART)) {
            return getInputStart();
        } else if (field.equals(INPUTEND)) {
            return getInputEnd();
        } else if (field.equals(ACTIVE)) {
            return getActive();
        } else if (field.equals(NOISEREDUCTION)) {
            return getNoiseReduction();
        } else if (field.equals(RED)) {
            return getRed();
        } else if (field.equals(GREEN)) {
            return getGreen();
        } else if (field.equals(BLUE)) {
            return getBlue();
        } else if (field.equals(ALPHA)) {
            return getAlpha();
        } else if (field.equals(LOOKUPTABLE)) {
            return getLookupTable();
        } else if (field.equals(SPATIALDOMAINENHANCEMENT)) {
            return getSpatialDomainEnhancement();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(RENDERINGDEF)) {
            setRenderingDef((ome.model.display.RenderingDef)value);
        } else if (field.equals(FAMILY)) {
            setFamily((ome.model.enums.Family)value);
        } else if (field.equals(COEFFICIENT)) {
            setCoefficient((java.lang.Double)value);
        } else if (field.equals(INPUTSTART)) {
            setInputStart((java.lang.Double)value);
        } else if (field.equals(INPUTEND)) {
            setInputEnd((java.lang.Double)value);
        } else if (field.equals(ACTIVE)) {
            setActive((java.lang.Boolean)value);
        } else if (field.equals(NOISEREDUCTION)) {
            setNoiseReduction((java.lang.Boolean)value);
        } else if (field.equals(RED)) {
            setRed((java.lang.Integer)value);
        } else if (field.equals(GREEN)) {
            setGreen((java.lang.Integer)value);
        } else if (field.equals(BLUE)) {
            setBlue((java.lang.Integer)value);
        } else if (field.equals(ALPHA)) {
            setAlpha((java.lang.Integer)value);
        } else if (field.equals(LOOKUPTABLE)) {
            setLookupTable((java.lang.String)value);
        } else if (field.equals(SPATIALDOMAINENHANCEMENT)) {
            setSpatialDomainEnhancement((java.util.List<ome.model.display.CodomainMapContext>)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.renderingDef = null;
        this.family = null;
        this.coefficient = null;
        this.inputStart = null;
        this.inputEnd = null;
        this.active = null;
        this.noiseReduction = null;
        this.red = null;
        this.green = null;
        this.blue = null;
        this.alpha = null;
        this.lookupTable = null;
        this.spatialDomainEnhancement = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKchannelbinding_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKchannelbinding_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKchannelbinding_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKchannelbinding_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKchannelbinding_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
