

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.enums;

import java.util.Arrays;

import ome.conditions.*;
import ome.model.*;

@javax.persistence.Entity
@javax.persistence.Table(name = "projectionaxis", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_projectionaxis",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_projectionaxis"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class ProjectionAxis
implements java.io.Serializable, IObject
, IGlobal, IEnum{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

    public final static String VALUE_T = "T";
    public final static String VALUE_MODULO_T = "ModuloT";
    public final static String VALUE_Z = "Z";
    public final static String VALUE_MODULO_Z = "ModuloZ";

    public ProjectionAxis () {
        this(null, true);
    }

    protected ProjectionAxis (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public ProjectionAxis (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }

    public ProjectionAxis (String value) {
        this(null, true);
        setValue(value);
    }


    public final static String ID = "ome.model.enums.ProjectionAxis_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_projectionaxis") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.String value = null;

   /**
    * Simple field ome.model.enums.ProjectionAxis.value (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=true, name="value", updatable=true)
    public java.lang.String getValue() {
        if (! _loaded ) errorIfUnloaded();
        return this.value;
    }

    public void setValue(java.lang.String value) {
        if (! _loaded ) errorIfUnloaded();
        this.value = (java.lang.String) value;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.enums.ProjectionAxis newInstance()
    {
        return new ome.model.enums.ProjectionAxis();
    }

    public ome.model.enums.ProjectionAxis proxy() {
        return new ome.model.enums.ProjectionAxis(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.value = (java.lang.String) __filter.filter(VALUE, this.value );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        sb.append(':');
        sb.append(value);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.enums.ProjectionAxis.FIELDS;
    }

    public final static String VALUE = "ome.model.enums.ProjectionAxis_value";
    public final static String DETAILS = "ome.model.enums.ProjectionAxis_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VALUE);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VALUE)) {
            return getValue();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VALUE)) {
            setValue((java.lang.String)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.value = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }



    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        } else if (other instanceof ProjectionAxis) {
            return value.equals(((ProjectionAxis) other).value);
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return Arrays.hashCode(new Object[] {ProjectionAxis.class, value});
    }



    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKprojectionaxis_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }



    }
}
