

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.meta;

import ome.conditions.*;
import ome.model.*;

@javax.persistence.Entity
@javax.persistence.Table(name = "event", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_event",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_event"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Event
implements java.io.Serializable, IObject
, IGlobal{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

    public Event () {
        this(null, true);
    }

    protected Event (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Event (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Event(
java.sql.Timestamp _time,ome.model.meta.Experimenter _experimenter,ome.model.meta.ExperimenterGroup _experimenterGroup,ome.model.enums.EventType _type,ome.model.meta.Session _session    ) {
        this(null, true);
        setTime(_time);
        setExperimenter(_experimenter);
        setExperimenterGroup(_experimenterGroup);
        setType(_type);
        setSession(_session);
    }

    public final static String ID = "ome.model.meta.Event_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_event") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.String status = null;

   /**
    * Simple field ome.model.meta.Event.status (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="status", updatable=true)
    public java.lang.String getStatus() {
        if (! _loaded ) errorIfUnloaded();
        return this.status;
    }

    public void setStatus(java.lang.String status) {
        if (! _loaded ) errorIfUnloaded();
        this.status = (java.lang.String) status;
    }
    protected java.sql.Timestamp time = null;

   /**
    * Simple field ome.model.meta.Event.time (java.sql.Timestamp) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.DateBridge(
        resolution=org.hibernate.search.annotations.Resolution.MINUTE)
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name = "combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="time", updatable=true)
    public java.sql.Timestamp getTime() {
        if (! _loaded ) errorIfUnloaded();
        return this.time;
    }

    public void setTime(java.sql.Timestamp time) {
        if (! _loaded ) errorIfUnloaded();
        this.time = (java.sql.Timestamp) time;
    }
    protected ome.model.meta.Experimenter experimenter = null;

   /**
    * Many-to-one field ome.model.meta.Event.experimenter (ome.model.meta.Experimenter)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.meta.Experimenter.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="experimenter", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKevent_experimenter_experimenter")
    public ome.model.meta.Experimenter getExperimenter() {
        if (! _loaded ) errorIfUnloaded();
        return this.experimenter;
    }

    public void setExperimenter(ome.model.meta.Experimenter experimenter) {
        if (! _loaded ) errorIfUnloaded();
        this.experimenter = experimenter;
    }
    protected ome.model.meta.ExperimenterGroup experimenterGroup = null;

   /**
    * Many-to-one field ome.model.meta.Event.experimenterGroup (ome.model.meta.ExperimenterGroup)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.meta.ExperimenterGroup.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="experimenterGroup", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKevent_experimenterGroup_experimentergroup")
    public ome.model.meta.ExperimenterGroup getExperimenterGroup() {
        if (! _loaded ) errorIfUnloaded();
        return this.experimenterGroup;
    }

    public void setExperimenterGroup(ome.model.meta.ExperimenterGroup experimenterGroup) {
        if (! _loaded ) errorIfUnloaded();
        this.experimenterGroup = experimenterGroup;
    }
    protected ome.model.enums.EventType type = null;

   /**
    * Many-to-one field ome.model.meta.Event.type (ome.model.enums.EventType)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.enums.EventType.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="type", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKevent_type_eventtype")
    public ome.model.enums.EventType getType() {
        if (! _loaded ) errorIfUnloaded();
        return this.type;
    }

    public void setType(ome.model.enums.EventType type) {
        if (! _loaded ) errorIfUnloaded();
        this.type = type;
    }
    protected ome.model.meta.Event containingEvent = null;

   /**
    * Many-to-one field ome.model.meta.Event.containingEvent (ome.model.meta.Event)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.meta.Event.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="containingEvent", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKevent_containingEvent_event")
    public ome.model.meta.Event getContainingEvent() {
        if (! _loaded ) errorIfUnloaded();
        return this.containingEvent;
    }

    public void setContainingEvent(ome.model.meta.Event containingEvent) {
        if (! _loaded ) errorIfUnloaded();
        this.containingEvent = containingEvent;
    }
    protected java.util.Set<ome.model.meta.EventLog> logs = new java.util.HashSet<ome.model.meta.EventLog>();


   /**
    * returns logs . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.meta.Event.logs (ome.model.meta.EventLog)
    */
    @javax.persistence.OneToMany(mappedBy="event", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    protected java.util.Set<ome.model.meta.EventLog> getLogs() {
        if (! _loaded ) errorIfUnloaded();
        return this.logs;
    }

    /**
     * setter for logs should be avoided. Does not fulfill normal semantics.
     */
    protected void setLogs(java.util.Set<ome.model.meta.EventLog> logs) {
        if (! _loaded ) errorIfUnloaded();
        this.logs = logs;
    }
    /**
     * returns the size of logs. If less than zero, the Set was null.
     */
    public int sizeOfLogs() {
        if (! _loaded ) errorIfUnloaded();
        return this.logs == null ? -1 : this.logs.size();
    }

    /**
     * should be used rather than accessing the logs set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfLogs()} is less than zero.
     */
    public java.util.Iterator<ome.model.meta.EventLog> iterateLogs() {
        if (! _loaded ) errorIfUnloaded();
        if ( getLogs() == null ) {
            return new ome.util.EmptyIterator<ome.model.meta.EventLog>();
        }
        return getLogs().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.meta.EventLog> unmodifiableLogs() {
        if (! _loaded ) errorIfUnloaded();
        if ( getLogs() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getLogs() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.meta.EventLog while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateLogs} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectLogs(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.meta.EventLog> it = iterateLogs();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setLogs . Makes the necessary
     * call on ome.model.meta.EventLog as well.
     */
    public void addEventLog(ome.model.meta.EventLog target) {
        if (! _loaded ) errorIfUnloaded();
        if (getLogs() == null) {
            throwNullCollectionException("Logs");
        }
        getLogs().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setEvent ( this );
         }
    }

    /**
     * use like addEventLog.
     */
    public void addEventLogSet(java.util.Collection<ome.model.meta.EventLog> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getLogs() == null) {
           throwNullCollectionException("Logs");
        }
        getLogs().addAll( targets );
        java.util.Iterator<ome.model.meta.EventLog> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.meta.EventLog target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setEvent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.meta.EventLog
     */
    public void removeEventLog(ome.model.meta.EventLog target) {
        if (! _loaded ) errorIfUnloaded();
        if (getLogs() == null) {
            throwNullCollectionException("Logs");
        }
        getLogs().remove( target );
            target.setEvent ( null );
    }

    /**
     * use like removeEventLog
     */
    public void removeEventLogSet(java.util.Collection<ome.model.meta.EventLog> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getLogs() == null) {
            throwNullCollectionException("Logs");
        }
        getLogs().removeAll( targets );
        java.util.Iterator<ome.model.meta.EventLog> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.meta.EventLog target = it.next();
                target.setEvent ( null );
        }
    }

    /**
     * clears the set.
     */
    public void clearLogs() {
        if (! _loaded ) errorIfUnloaded();
        if (getLogs() == null) {
            throwNullCollectionException("Logs");
        }
        getLogs().clear();
        java.util.Iterator<ome.model.meta.EventLog> it = iterateLogs();
        while (it.hasNext()) {
            ome.model.meta.EventLog target = it.next();
            target.setEvent ( null );
        }
    }


    protected ome.model.meta.Session session = null;

   /**
    * Many-to-one field ome.model.meta.Event.session (ome.model.meta.Session)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.meta.Session.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="\"session\"", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKevent_session_session")
    public ome.model.meta.Session getSession() {
        if (! _loaded ) errorIfUnloaded();
        return this.session;
    }

    public void setSession(ome.model.meta.Session session) {
        if (! _loaded ) errorIfUnloaded();
        this.session = session;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.meta.Event newInstance()
    {
        return new ome.model.meta.Event();
    }

    public ome.model.meta.Event proxy() {
        return new ome.model.meta.Event(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.status = (java.lang.String) __filter.filter(STATUS, this.status );
            this.time = (java.sql.Timestamp) __filter.filter(TIME, this.time );
            this.experimenter = (ome.model.meta.Experimenter) __filter.filter(EXPERIMENTER, this.experimenter );
            this.experimenterGroup = (ome.model.meta.ExperimenterGroup) __filter.filter(EXPERIMENTERGROUP, this.experimenterGroup );
            this.type = (ome.model.enums.EventType) __filter.filter(TYPE, this.type );
            this.containingEvent = (ome.model.meta.Event) __filter.filter(CONTAININGEVENT, this.containingEvent );
            this.logs = (java.util.Set<ome.model.meta.EventLog>) __filter.filter(LOGS, this.logs );
            this.session = (ome.model.meta.Session) __filter.filter(SESSION, this.session );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.meta.Event.FIELDS;
    }

    public final static String STATUS = "ome.model.meta.Event_status";
    public final static String TIME = "ome.model.meta.Event_time";
    public final static String EXPERIMENTER = "ome.model.meta.Event_experimenter";
    public final static String EXPERIMENTERGROUP = "ome.model.meta.Event_experimenterGroup";
    public final static String TYPE = "ome.model.meta.Event_type";
    public final static String CONTAININGEVENT = "ome.model.meta.Event_containingEvent";
    public final static String LOGS = "ome.model.meta.Event_logs";
    public final static String SESSION = "ome.model.meta.Event_session";
    public final static String DETAILS = "ome.model.meta.Event_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(STATUS);
       raw.add(TIME);
       raw.add(EXPERIMENTER);
       raw.add(EXPERIMENTERGROUP);
       raw.add(TYPE);
       raw.add(CONTAININGEVENT);
       raw.add(LOGS);
       raw.add(SESSION);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(STATUS)) {
            return getStatus();
        } else if (field.equals(TIME)) {
            return getTime();
        } else if (field.equals(EXPERIMENTER)) {
            return getExperimenter();
        } else if (field.equals(EXPERIMENTERGROUP)) {
            return getExperimenterGroup();
        } else if (field.equals(TYPE)) {
            return getType();
        } else if (field.equals(CONTAININGEVENT)) {
            return getContainingEvent();
        } else if (field.equals(LOGS)) {
            return getLogs();
        } else if (field.equals(SESSION)) {
            return getSession();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(STATUS)) {
            setStatus((java.lang.String)value);
        } else if (field.equals(TIME)) {
            setTime((java.sql.Timestamp)value);
        } else if (field.equals(EXPERIMENTER)) {
            setExperimenter((ome.model.meta.Experimenter)value);
        } else if (field.equals(EXPERIMENTERGROUP)) {
            setExperimenterGroup((ome.model.meta.ExperimenterGroup)value);
        } else if (field.equals(TYPE)) {
            setType((ome.model.enums.EventType)value);
        } else if (field.equals(CONTAININGEVENT)) {
            setContainingEvent((ome.model.meta.Event)value);
        } else if (field.equals(LOGS)) {
            setLogs((java.util.Set<ome.model.meta.EventLog>)value);
        } else if (field.equals(SESSION)) {
            setSession((ome.model.meta.Session)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.status = null;
        this.time = null;
        this.experimenter = null;
        this.experimenterGroup = null;
        this.type = null;
        this.containingEvent = null;
        this.logs = null;
        this.session = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKevent_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }



    }
}
