

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.meta;

import ome.conditions.*;
import ome.model.*;

@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="owner_or_admin",
            parameters={
                @org.hibernate.annotations.ParamDef( name="current_user", type="java.lang.Long" ),
                @org.hibernate.annotations.ParamDef( name="is_admin", type="java.lang.Integer" )})
})
@org.hibernate.annotations.Filters({
    @org.hibernate.annotations.Filter(name="owner_or_admin", condition="(1 = :is_admin or owner = :current_user)"),
    @org.hibernate.annotations.Filter(name="LightAdminPrivilegesSecurityFilter",
                                      condition="(COALESCE(sudoer, owner) = :real_owner OR 'ReadSession' IN (:privileges))")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "session", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_session",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_session"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Session
implements java.io.Serializable, IObject
, IGlobal, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

    public Session () {
        this(null, true);
    }

    protected Session (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Session (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }


    public Session(
ome.model.meta.Node _node,java.lang.String _uuid,ome.model.meta.Experimenter _owner,java.lang.Long _timeToIdle,java.lang.Long _timeToLive,java.sql.Timestamp _started,java.lang.String _defaultEventType    ) {
        this(null, true);
        setNode(_node);
        setUuid(_uuid);
        setOwner(_owner);
        setTimeToIdle(_timeToIdle);
        setTimeToLive(_timeToLive);
        setStarted(_started);
        setDefaultEventType(_defaultEventType);
    }

    public final static String ID = "ome.model.meta.Session_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_session") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.meta.Session_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected ome.model.meta.Node node = null;

   /**
    * Many-to-one field ome.model.meta.Session.node (ome.model.meta.Node)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.meta.Node.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="node", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKsession_node_node")
    public ome.model.meta.Node getNode() {
        if (! _loaded ) errorIfUnloaded();
        return this.node;
    }

    public void setNode(ome.model.meta.Node node) {
        if (! _loaded ) errorIfUnloaded();
        this.node = node;
    }
    protected java.lang.String uuid = null;

   /**
    * Simple field ome.model.meta.Session.uuid (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=true, name="uuid", updatable=true)
    public java.lang.String getUuid() {
        if (! _loaded ) errorIfUnloaded();
        return this.uuid;
    }

    public void setUuid(java.lang.String uuid) {
        if (! _loaded ) errorIfUnloaded();
        this.uuid = (java.lang.String) uuid;
    }
    protected ome.model.meta.Experimenter owner = null;

   /**
    * Many-to-one field ome.model.meta.Session.owner (ome.model.meta.Experimenter)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.meta.Experimenter.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="owner", nullable=false,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKsession_owner_experimenter")
    public ome.model.meta.Experimenter getOwner() {
        if (! _loaded ) errorIfUnloaded();
        return this.owner;
    }

    public void setOwner(ome.model.meta.Experimenter owner) {
        if (! _loaded ) errorIfUnloaded();
        this.owner = owner;
    }
    protected ome.model.meta.Experimenter sudoer = null;

   /**
    * Many-to-one field ome.model.meta.Session.sudoer (ome.model.meta.Experimenter)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.meta.Experimenter.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="sudoer", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKsession_sudoer_experimenter")
    public ome.model.meta.Experimenter getSudoer() {
        if (! _loaded ) errorIfUnloaded();
        return this.sudoer;
    }

    public void setSudoer(ome.model.meta.Experimenter sudoer) {
        if (! _loaded ) errorIfUnloaded();
        this.sudoer = sudoer;
    }
    protected java.lang.Long timeToIdle = null;

   /**
    * Simple field ome.model.meta.Session.timeToIdle (java.lang.Long) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="timeToIdle", updatable=true)
    public java.lang.Long getTimeToIdle() {
        if (! _loaded ) errorIfUnloaded();
        return this.timeToIdle;
    }

    public void setTimeToIdle(java.lang.Long timeToIdle) {
        if (! _loaded ) errorIfUnloaded();
        this.timeToIdle = (java.lang.Long) timeToIdle;
    }
    protected java.lang.Long timeToLive = null;

   /**
    * Simple field ome.model.meta.Session.timeToLive (java.lang.Long) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="timeToLive", updatable=true)
    public java.lang.Long getTimeToLive() {
        if (! _loaded ) errorIfUnloaded();
        return this.timeToLive;
    }

    public void setTimeToLive(java.lang.Long timeToLive) {
        if (! _loaded ) errorIfUnloaded();
        this.timeToLive = (java.lang.Long) timeToLive;
    }
    protected java.sql.Timestamp started = null;

   /**
    * Simple field ome.model.meta.Session.started (java.sql.Timestamp) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.DateBridge(
        resolution=org.hibernate.search.annotations.Resolution.MINUTE)
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name = "combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="started", updatable=true)
    public java.sql.Timestamp getStarted() {
        if (! _loaded ) errorIfUnloaded();
        return this.started;
    }

    public void setStarted(java.sql.Timestamp started) {
        if (! _loaded ) errorIfUnloaded();
        this.started = (java.sql.Timestamp) started;
    }
    protected java.sql.Timestamp closed = null;

   /**
    * Simple field ome.model.meta.Session.closed (java.sql.Timestamp) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.DateBridge(
        resolution=org.hibernate.search.annotations.Resolution.MINUTE)
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.UN_TOKENIZED,
            name = "combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="closed", updatable=true)
    public java.sql.Timestamp getClosed() {
        if (! _loaded ) errorIfUnloaded();
        return this.closed;
    }

    public void setClosed(java.sql.Timestamp closed) {
        if (! _loaded ) errorIfUnloaded();
        this.closed = (java.sql.Timestamp) closed;
    }
    protected java.lang.String message = null;

   /**
    * Simple field ome.model.meta.Session.message (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="message", updatable=true)
    public java.lang.String getMessage() {
        if (! _loaded ) errorIfUnloaded();
        return this.message;
    }

    public void setMessage(java.lang.String message) {
        if (! _loaded ) errorIfUnloaded();
        this.message = (java.lang.String) message;
    }
    protected java.lang.String defaultEventType = null;

   /**
    * Simple field ome.model.meta.Session.defaultEventType (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=false, unique=false, name="defaultEventType", updatable=true)
    public java.lang.String getDefaultEventType() {
        if (! _loaded ) errorIfUnloaded();
        return this.defaultEventType;
    }

    public void setDefaultEventType(java.lang.String defaultEventType) {
        if (! _loaded ) errorIfUnloaded();
        this.defaultEventType = (java.lang.String) defaultEventType;
    }
    protected java.lang.String userAgent = null;

   /**
    * Simple field ome.model.meta.Session.userAgent (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="userAgent", updatable=true)
    public java.lang.String getUserAgent() {
        if (! _loaded ) errorIfUnloaded();
        return this.userAgent;
    }

    public void setUserAgent(java.lang.String userAgent) {
        if (! _loaded ) errorIfUnloaded();
        this.userAgent = (java.lang.String) userAgent;
    }
    protected java.lang.String userIP = null;

   /**
    * Simple field ome.model.meta.Session.userIP (java.lang.String) 
    */
    // No @Type annotation
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="userIP", updatable=true)
    public java.lang.String getUserIP() {
        if (! _loaded ) errorIfUnloaded();
        return this.userIP;
    }

    public void setUserIP(java.lang.String userIP) {
        if (! _loaded ) errorIfUnloaded();
        this.userIP = (java.lang.String) userIP;
    }
    protected java.util.Set<ome.model.meta.Event> events = new java.util.HashSet<ome.model.meta.Event>();


   /**
    * returns events . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.meta.Session.events (ome.model.meta.Event)
    */
    @javax.persistence.OneToMany(mappedBy="session", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    protected java.util.Set<ome.model.meta.Event> getEvents() {
        if (! _loaded ) errorIfUnloaded();
        return this.events;
    }

    /**
     * setter for events should be avoided. Does not fulfill normal semantics.
     */
    protected void setEvents(java.util.Set<ome.model.meta.Event> events) {
        if (! _loaded ) errorIfUnloaded();
        this.events = events;
    }
    /**
     * returns the size of events. If less than zero, the Set was null.
     */
    public int sizeOfEvents() {
        if (! _loaded ) errorIfUnloaded();
        return this.events == null ? -1 : this.events.size();
    }

    /**
     * should be used rather than accessing the events set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfEvents()} is less than zero.
     */
    public java.util.Iterator<ome.model.meta.Event> iterateEvents() {
        if (! _loaded ) errorIfUnloaded();
        if ( getEvents() == null ) {
            return new ome.util.EmptyIterator<ome.model.meta.Event>();
        }
        return getEvents().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.meta.Event> unmodifiableEvents() {
        if (! _loaded ) errorIfUnloaded();
        if ( getEvents() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getEvents() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.meta.Event while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateEvents} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectEvents(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.meta.Event> it = iterateEvents();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setEvents . Makes the necessary
     * call on ome.model.meta.Event as well.
     */
    public void addEvent(ome.model.meta.Event target) {
        if (! _loaded ) errorIfUnloaded();
        if (getEvents() == null) {
            throwNullCollectionException("Events");
        }
        getEvents().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setSession ( this );
         }
    }

    /**
     * use like addEvent.
     */
    public void addEventSet(java.util.Collection<ome.model.meta.Event> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getEvents() == null) {
           throwNullCollectionException("Events");
        }
        getEvents().addAll( targets );
        java.util.Iterator<ome.model.meta.Event> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.meta.Event target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setSession ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.meta.Event
     */
    public void removeEvent(ome.model.meta.Event target) {
        if (! _loaded ) errorIfUnloaded();
        if (getEvents() == null) {
            throwNullCollectionException("Events");
        }
        getEvents().remove( target );
            target.setSession ( null );
    }

    /**
     * use like removeEvent
     */
    public void removeEventSet(java.util.Collection<ome.model.meta.Event> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getEvents() == null) {
            throwNullCollectionException("Events");
        }
        getEvents().removeAll( targets );
        java.util.Iterator<ome.model.meta.Event> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.meta.Event target = it.next();
                target.setSession ( null );
        }
    }

    /**
     * clears the set.
     */
    public void clearEvents() {
        if (! _loaded ) errorIfUnloaded();
        if (getEvents() == null) {
            throwNullCollectionException("Events");
        }
        getEvents().clear();
        java.util.Iterator<ome.model.meta.Event> it = iterateEvents();
        while (it.hasNext()) {
            ome.model.meta.Event target = it.next();
            target.setSession ( null );
        }
    }


    protected java.util.Set<ome.model.annotations.SessionAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.SessionAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "session_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "session_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "session_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "session_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.meta.Session.annotationLinks (ome.model.annotations.SessionAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.SessionAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.SessionAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.SessionAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.SessionAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.annotations.SessionAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.SessionAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.SessionAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.SessionAnnotationLink as well.
     */
    public void addSessionAnnotationLink(ome.model.annotations.SessionAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addSessionAnnotationLink.
     */
    public void addSessionAnnotationLinkSet(java.util.Collection<ome.model.annotations.SessionAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.SessionAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.SessionAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.SessionAnnotationLink
     */
    public void removeSessionAnnotationLink(ome.model.annotations.SessionAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeSessionAnnotationLink
     */
    public void removeSessionAnnotationLinkSet(java.util.Collection<ome.model.annotations.SessionAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.SessionAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.SessionAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.SessionAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.SessionAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.SessionAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.SessionAnnotationLink link = new ome.model.annotations.SessionAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addSessionAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.SessionAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addSessionAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addSessionAnnotationLink (ome.model.annotations.SessionAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.SessionAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.SessionAnnotationLink link = (ome.model.annotations.SessionAnnotationLink) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.SessionAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.SessionAnnotationLink> findSessionAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.SessionAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.SessionAnnotationLink> result = new java.util.HashSet<ome.model.annotations.SessionAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.SessionAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.SessionAnnotationLink> toRemove = findSessionAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.SessionAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeSessionAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given SessionAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkSession again <b>if loaded</b>.
     */
    public void removeSessionAnnotationLink (ome.model.annotations.SessionAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.SessionAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.SessionAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.SessionAnnotationLink link : list) {
            removeSessionAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Session_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.SessionAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Session_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Session_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Session_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.meta.Session newInstance()
    {
        return new ome.model.meta.Session();
    }

    public ome.model.meta.Session proxy() {
        return new ome.model.meta.Session(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.node = (ome.model.meta.Node) __filter.filter(NODE, this.node );
            this.uuid = (java.lang.String) __filter.filter(UUID, this.uuid );
            this.owner = (ome.model.meta.Experimenter) __filter.filter(OWNER, this.owner );
            this.sudoer = (ome.model.meta.Experimenter) __filter.filter(SUDOER, this.sudoer );
            this.timeToIdle = (java.lang.Long) __filter.filter(TIMETOIDLE, this.timeToIdle );
            this.timeToLive = (java.lang.Long) __filter.filter(TIMETOLIVE, this.timeToLive );
            this.started = (java.sql.Timestamp) __filter.filter(STARTED, this.started );
            this.closed = (java.sql.Timestamp) __filter.filter(CLOSED, this.closed );
            this.message = (java.lang.String) __filter.filter(MESSAGE, this.message );
            this.defaultEventType = (java.lang.String) __filter.filter(DEFAULTEVENTTYPE, this.defaultEventType );
            this.userAgent = (java.lang.String) __filter.filter(USERAGENT, this.userAgent );
            this.userIP = (java.lang.String) __filter.filter(USERIP, this.userIP );
            this.events = (java.util.Set<ome.model.meta.Event>) __filter.filter(EVENTS, this.events );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.SessionAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.meta.Session.FIELDS;
    }

    public final static String NODE = "ome.model.meta.Session_node";
    public final static String UUID = "ome.model.meta.Session_uuid";
    public final static String OWNER = "ome.model.meta.Session_owner";
    public final static String SUDOER = "ome.model.meta.Session_sudoer";
    public final static String TIMETOIDLE = "ome.model.meta.Session_timeToIdle";
    public final static String TIMETOLIVE = "ome.model.meta.Session_timeToLive";
    public final static String STARTED = "ome.model.meta.Session_started";
    public final static String CLOSED = "ome.model.meta.Session_closed";
    public final static String MESSAGE = "ome.model.meta.Session_message";
    public final static String DEFAULTEVENTTYPE = "ome.model.meta.Session_defaultEventType";
    public final static String USERAGENT = "ome.model.meta.Session_userAgent";
    public final static String USERIP = "ome.model.meta.Session_userIP";
    public final static String EVENTS = "ome.model.meta.Session_events";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.meta.Session_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.meta.Session_annotationLinks";
    public final static String DETAILS = "ome.model.meta.Session_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(NODE);
       raw.add(UUID);
       raw.add(OWNER);
       raw.add(SUDOER);
       raw.add(TIMETOIDLE);
       raw.add(TIMETOLIVE);
       raw.add(STARTED);
       raw.add(CLOSED);
       raw.add(MESSAGE);
       raw.add(DEFAULTEVENTTYPE);
       raw.add(USERAGENT);
       raw.add(USERIP);
       raw.add(EVENTS);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(NODE)) {
            return getNode();
        } else if (field.equals(UUID)) {
            return getUuid();
        } else if (field.equals(OWNER)) {
            return getOwner();
        } else if (field.equals(SUDOER)) {
            return getSudoer();
        } else if (field.equals(TIMETOIDLE)) {
            return getTimeToIdle();
        } else if (field.equals(TIMETOLIVE)) {
            return getTimeToLive();
        } else if (field.equals(STARTED)) {
            return getStarted();
        } else if (field.equals(CLOSED)) {
            return getClosed();
        } else if (field.equals(MESSAGE)) {
            return getMessage();
        } else if (field.equals(DEFAULTEVENTTYPE)) {
            return getDefaultEventType();
        } else if (field.equals(USERAGENT)) {
            return getUserAgent();
        } else if (field.equals(USERIP)) {
            return getUserIP();
        } else if (field.equals(EVENTS)) {
            return getEvents();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) {
            return getAnnotationLinks();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(NODE)) {
            setNode((ome.model.meta.Node)value);
        } else if (field.equals(UUID)) {
            setUuid((java.lang.String)value);
        } else if (field.equals(OWNER)) {
            setOwner((ome.model.meta.Experimenter)value);
        } else if (field.equals(SUDOER)) {
            setSudoer((ome.model.meta.Experimenter)value);
        } else if (field.equals(TIMETOIDLE)) {
            setTimeToIdle((java.lang.Long)value);
        } else if (field.equals(TIMETOLIVE)) {
            setTimeToLive((java.lang.Long)value);
        } else if (field.equals(STARTED)) {
            setStarted((java.sql.Timestamp)value);
        } else if (field.equals(CLOSED)) {
            setClosed((java.sql.Timestamp)value);
        } else if (field.equals(MESSAGE)) {
            setMessage((java.lang.String)value);
        } else if (field.equals(DEFAULTEVENTTYPE)) {
            setDefaultEventType((java.lang.String)value);
        } else if (field.equals(USERAGENT)) {
            setUserAgent((java.lang.String)value);
        } else if (field.equals(USERIP)) {
            setUserIP((java.lang.String)value);
        } else if (field.equals(EVENTS)) {
            setEvents((java.util.Set<ome.model.meta.Event>)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.SessionAnnotationLink>)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.node = null;
        this.uuid = null;
        this.owner = null;
        this.sudoer = null;
        this.timeToIdle = null;
        this.timeToLive = null;
        this.started = null;
        this.closed = null;
        this.message = null;
        this.defaultEventType = null;
        this.userAgent = null;
        this.userIP = null;
        this.events = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKsession_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }



    }
}
