

/*
 *   This file was generated by dsl/resources/ome/dsl/object.vm
 *
 *   Copyright (c) 2007 Glencoe Software Inc. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

package ome.model.roi;

import ome.conditions.*;
import ome.model.*;

/**
 * These filter definitions are used by the security system
 * to eliminate non-readable objects from queries. The regular
 * user does not need to worry about them, as they will be
 * injected directly into the SQL (not HQL)
 */
@org.hibernate.annotations.FilterDefs({
    @org.hibernate.annotations.FilterDef(name="roi_owner_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="roi_group_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="roi_event_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="roi_perms_filter",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" )),
    @org.hibernate.annotations.FilterDef(name="roi_owner_filter_SHAPES",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="roi_group_filter_SHAPES",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="roi_event_filter_SHAPES",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="roi_perms_filter_SHAPES",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="roi_owner_filter_FOLDERLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="roi_group_filter_FOLDERLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="roi_event_filter_FOLDERLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="roi_perms_filter_FOLDERLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
,
    @org.hibernate.annotations.FilterDef(name="roi_owner_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="ownerId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="roi_group_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="groupId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="roi_event_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="eventId", type="java.lang.Long" )),
    @org.hibernate.annotations.FilterDef(name="roi_perms_filter_ANNOTATIONLINKS",
        parameters=@org.hibernate.annotations.ParamDef( name="permsStr", type="java.lang.String" ))
})
@org.hibernate.annotations.Filters({
    // See the comments on filters above
    @org.hibernate.annotations.Filter(name="roi_owner_filter", condition=":ownerId = owner_id"),
    @org.hibernate.annotations.Filter(name="roi_group_filter", condition=":groupId = group_id"),
    @org.hibernate.annotations.Filter(name="roi_event_filter", condition=":eventId = event_id"),
    @org.hibernate.annotations.Filter(name="roi_perms_filter", condition=":permsStr = permissions"),
    @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
    @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
    @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)")
})
@javax.persistence.Entity
@javax.persistence.Table(name = "roi", uniqueConstraints = {
})
@org.hibernate.annotations.Entity( selectBeforeUpdate = true )
@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@org.hibernate.annotations.GenericGenerator(name = "seq_roi",
        strategy = "ome.util.TableIdGenerator",
        parameters = {
            @org.hibernate.annotations.Parameter(name = "table_name", value = "seq_table"),
            @org.hibernate.annotations.Parameter(name = "segment_value", value = "seq_roi"),
            @org.hibernate.annotations.Parameter(name = "optimizer", value = "pooled"),
            @org.hibernate.annotations.Parameter(name = "increment_size", value = "50")
        })
@org.hibernate.search.annotations.Indexed(index="FullText")
@org.hibernate.search.annotations.ClassBridge(
    name="details",
    impl = ome.util.DetailsFieldBridge.class,
    index=org.hibernate.search.annotations.Index.UN_TOKENIZED,
    store=org.hibernate.search.annotations.Store.NO
)
public  class Roi
implements java.io.Serializable, IObject
, IMutable, IAnnotated{

   /* These values are defined in dsl/resources/ome/dsl/object.vm:
    * -------------------------------------------------------------
    * Explanation of serialVersionUID ex 0000000 03 00 00 01 03 01 L;
    * 1-7   : currently unused
    * 8-9   : major part (3.x.x)
    * 10-11 : minor part (x.0.x)
    * 12-13 : patch part (x.x.0)
    * 14-15 : release type   (B)
    * 16-17 : release number (3)
    * 18-19 : increment per delta // any changes to the dsl or mapping files
    */
    private static final long serialVersionUID = 0000000030000020302L;

   /*
    * Constants naming filters used by the OMERO
    * security system.
    */
    public final static String OWNER_FILTER = "roi_owner_filter";
    public final static String GROUP_FILTER = "roi_group_filter";
    public final static String EVENT_FILTER = "roi_event_filter";
    public final static String PERMS_FILTER = "roi_perms_filter";

    public Roi () {
        this(null, true);
    }

    protected Roi (Long id) {
        this(id, true);
    }

    /**
     * Main constructor.
     */
    public Roi (Long id, boolean loaded) {
        setId(id);
        if (loaded) {
            getDetails().setContext(this);
        } else {
            if (this.id == null) {
                throw new ApiUsageException("Id cannot be null for a proxy");
            }
            unload();
        }
    }



    public final static String ID = "ome.model.roi.Roi_id";
    
    protected Long id;

   /**
    * The DB unique identifier for this object. You are not responsible for
    * setting the id; however, it can be useful for creating "unloaded"
    * versions of your objects.
    *
    * Each top-level entity contains an id field of type long.
    * For all objects returned from the server, this value will
    * be non-null, which doesn't necessarily hold for the other
    * fields.
    */
    @javax.persistence.Id
    @javax.persistence.GeneratedValue(
        strategy=javax.persistence.GenerationType.SEQUENCE,
        generator="seq_roi") 
    @org.hibernate.search.annotations.DocumentId
    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }


   /*
    *    INTERFACE-BASED
    *    Several properties are defined by whether or not
    *    the OME definition has certain interfaces.
    */

    public final static String VERSION = "ome.model.roi.Roi_version";

    protected Integer version = 0;

   /**
    * This version number is controlled by the database for optimisitic
    * locking.
    */
    @javax.persistence.Column(name="version") 
    // @javax.persistence.Version 
//TODO mark off #118 if this succeeds, otherwise, completely remove versions and test updateEvent
    @Override
    public Integer getVersion() {
        if (! _loaded ) errorIfUnloaded();
        return this.version;
    }

    @Override
    public void setVersion(Integer version) {
        if (! _loaded ) errorIfUnloaded();
        this.version = version;
    }


   /*
    *    PROPERTIES
    *    All properties which follow are straightforward
    *    and can be understood using only the Hibernate
    *    documentation.
    */

    protected java.lang.String name = null;

   /**
    * Simple field ome.model.roi.Roi.name (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="name", updatable=true)
    public java.lang.String getName() {
        if (! _loaded ) errorIfUnloaded();
        return this.name;
    }

    public void setName(java.lang.String name) {
        if (! _loaded ) errorIfUnloaded();
        this.name = (java.lang.String) name;
    }
    protected java.util.List<ome.model.roi.Shape> shapes = new java.util.ArrayList<ome.model.roi.Shape>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_SHAPES = "roi_owner_filter_SHAPES";
    public final static String GROUP_FILTER_SHAPES = "roi_group_filter_SHAPES";
    public final static String EVENT_FILTER_SHAPES = "roi_event_filter_SHAPES";
    public final static String PERMS_FILTER_SHAPES = "roi_perms_filter_SHAPES";

   /**
    * returns shapes . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many List ome.model.roi.Roi.shapes (ome.model.roi.Shape)
    * Values are indexed by the column "index" on ome.model.roi.Shape
    */
    @javax.persistence.JoinColumn(name="roi", nullable=false)
    @javax.persistence.OneToMany(fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.IndexColumn(name="roi_index", nullable=false)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_SHAPES, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_SHAPES, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_SHAPES, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_SHAPES, condition=":permsStr = permissions")
    })
    protected java.util.List<ome.model.roi.Shape> getShapes() {
        if (! _loaded ) errorIfUnloaded();
        return this.shapes;
    }

    /**
     * setter for shapes should be avoided. Does not fulfill normal semantics.
     */
    protected void setShapes(java.util.List<ome.model.roi.Shape> shapes) {
        if (! _loaded ) errorIfUnloaded();
        this.shapes = shapes;
    }
    /**
     * returns the size of shapes. If less than zero, the Set was null.
     */
    public int sizeOfShapes() {
        if (! _loaded ) errorIfUnloaded();
        return this.shapes == null ? -1 : this.shapes.size();
    }

    /**
     * should be used rather than accessing the shapes set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfShapes()} is less than zero.
     */
    public java.util.Iterator<ome.model.roi.Shape> iterateShapes() {
        if (! _loaded ) errorIfUnloaded();
        if ( getShapes() == null ) {
            return new ome.util.EmptyIterator<ome.model.roi.Shape>();
        }
        return getShapes().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.roi.Shape> unmodifiableShapes() {
        if (! _loaded ) errorIfUnloaded();
        if ( getShapes() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getShapes() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.roi.Shape while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateShapes} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectShapes(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.roi.Shape> it = iterateShapes();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setShapes . Makes the necessary
     * call on ome.model.roi.Shape as well.
     */
    public void addShape(ome.model.roi.Shape target) {
        if (! _loaded ) errorIfUnloaded();
        if (getShapes() == null) {
            throwNullCollectionException("Shapes");
        }
        getShapes().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
            if (target.isLoaded()) {
                target.setRoi ( this );
             }
         }
    }

    /**
     * use like addShape.
     */
    public void addShapeSet(java.util.Collection<ome.model.roi.Shape> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getShapes() == null) {
           throwNullCollectionException("Shapes");
        }
        getShapes().addAll( targets );
        java.util.Iterator<ome.model.roi.Shape> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.roi.Shape target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                if (target.isLoaded()) {
                    target.setRoi ( this );
                }
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.roi.Shape
     */
    public void removeShape(ome.model.roi.Shape target) {
        if (! _loaded ) errorIfUnloaded();
        if (getShapes() == null) {
            throwNullCollectionException("Shapes");
        }
        getShapes().remove( target );
        if (target.isLoaded()) {
            target.setRoi ( null );
        }
    }

    /**
     * use like removeShape
     */
    public void removeShapeSet(java.util.Collection<ome.model.roi.Shape> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getShapes() == null) {
            throwNullCollectionException("Shapes");
        }
        getShapes().removeAll( targets );
        java.util.Iterator<ome.model.roi.Shape> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.roi.Shape target = it.next();
            if (target.isLoaded()) {
                target.setRoi ( null );
            }
        }
    }

    /**
     * clears the set.
     */
    public void clearShapes() {
        if (! _loaded ) errorIfUnloaded();
        if (getShapes() == null) {
            throwNullCollectionException("Shapes");
        }
        getShapes().clear();
        java.util.Iterator<ome.model.roi.Shape> it = iterateShapes();
        while (it.hasNext()) {
            ome.model.roi.Shape target = it.next();
            target.setRoi ( null );
        }
    }


    /**
     * Gets the ome.model.roi.Shape at the given index.
     */
    public ome.model.roi.Shape getShape(int index)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getShapes() == null) {
            throwNullCollectionException("Shapes");
        }
        return getShapes().get(index);
    }

    /**
     * Sets the ome.model.roi.Shape at the given index. Adheres to the {@link java.util.List#set(int, Object)}
     * contract. To extend the list, use {@link #addShape(Shape)}.
     * @see java.util.List#set(int, Object)
     */
    public ome.model.roi.Shape setShape(int index, ome.model.roi.Shape element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getShapes() == null) {
            throwNullCollectionException("Shapes");
        }

        ome.model.roi.Shape old = getShapes().set(index, element);

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (element != null) {
            if (element.isLoaded()) {
                element.setRoi ( this );
            }
        }

        return old;
    }

    /**
     * Gets the first element of shapes which can be interpreted as the
     * primary or default element in some situations. If there is not first
     * element, an {@link IndexOutOfBoundsException} is throws. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfShapes()} for more information.
     */
    @javax.persistence.Transient
    public ome.model.roi.Shape getPrimaryShape()
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getShapes() == null) {
            throwNullCollectionException("Shapes");
        }
        return getShapes().get(0);
    }

    /**
     * Swaps the first element of shapes with the first instance of the
     * given element. If the given element is not in the list, an
     * {@link IndexOutOfBoundsException} will be thrown. Returns the swapped
     * element. This method
     * will also throw an {@link ApiUsageException} if the collection is
     * unloaded. See {@link #sizeOfShapes()} for more information.
     */
    public ome.model.roi.Shape setPrimaryShape(ome.model.roi.Shape element)
    throws IndexOutOfBoundsException {
        if (! _loaded ) errorIfUnloaded();
        if (getShapes() == null) {
            throwNullCollectionException("Shapes");
        }
        java.util.List<ome.model.roi.Shape> list = getShapes();
        int index = list.indexOf(element);
        ome.model.roi.Shape old = list.get(0);
        list.set(index, old);
        list.set(0, element);
        return old;
    }
    
    
    protected ome.model.core.Image image = null;

   /**
    * Many-to-one field ome.model.roi.Roi.image (ome.model.core.Image)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.core.Image.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="image", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKroi_image_image")
    public ome.model.core.Image getImage() {
        if (! _loaded ) errorIfUnloaded();
        return this.image;
    }

    public void setImage(ome.model.core.Image image) {
        if (! _loaded ) errorIfUnloaded();
        this.image = image;
    }
    protected ome.model.core.OriginalFile source = null;

   /**
    * Many-to-one field ome.model.roi.Roi.source (ome.model.core.OriginalFile)
    */
    @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}, targetEntity = ome.model.core.OriginalFile.class)
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
    @javax.persistence.JoinColumn(name="source", nullable=true,
        unique=false, insertable=true, updatable=true)
    @org.hibernate.annotations.ForeignKey(name="FKroi_source_originalfile")
    public ome.model.core.OriginalFile getSource() {
        if (! _loaded ) errorIfUnloaded();
        return this.source;
    }

    public void setSource(ome.model.core.OriginalFile source) {
        if (! _loaded ) errorIfUnloaded();
        this.source = source;
    }
    protected java.util.Set<ome.model.containers.FolderRoiLink> folderLinks = new java.util.HashSet<ome.model.containers.FolderRoiLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_FOLDERLINKS = "roi_owner_filter_FOLDERLINKS";
    public final static String GROUP_FILTER_FOLDERLINKS = "roi_group_filter_FOLDERLINKS";
    public final static String EVENT_FILTER_FOLDERLINKS = "roi_event_filter_FOLDERLINKS";
    public final static String PERMS_FILTER_FOLDERLINKS = "roi_perms_filter_FOLDERLINKS";

   /**
    * returns folderLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.roi.Roi.folderLinks (ome.model.containers.FolderRoiLink)
    */
    @javax.persistence.OneToMany(mappedBy="child", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_FOLDERLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_FOLDERLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_FOLDERLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_FOLDERLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.containers.FolderRoiLink> getFolderLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.folderLinks;
    }

    /**
     * setter for folderLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setFolderLinks(java.util.Set<ome.model.containers.FolderRoiLink> folderLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.folderLinks = folderLinks;
    }
    /**
     * returns the size of folderLinks. If less than zero, the Set was null.
     */
    public int sizeOfFolderLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.folderLinks == null ? -1 : this.folderLinks.size();
    }

    /**
     * should be used rather than accessing the folderLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfFolderLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.containers.FolderRoiLink> iterateFolderLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getFolderLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.containers.FolderRoiLink>();
        }
        return getFolderLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.containers.FolderRoiLink> unmodifiableFolderLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getFolderLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getFolderLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.containers.FolderRoiLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateFolderLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectFolderLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.containers.FolderRoiLink> it = iterateFolderLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setFolderLinks . Makes the necessary
     * call on ome.model.containers.FolderRoiLink as well.
     */
    public void addFolderRoiLink(ome.model.containers.FolderRoiLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getFolderLinks() == null) {
            throwNullCollectionException("FolderLinks");
        }
        getFolderLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setChild ( this );
         }
    }

    /**
     * use like addFolderRoiLink.
     */
    public void addFolderRoiLinkSet(java.util.Collection<ome.model.containers.FolderRoiLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getFolderLinks() == null) {
           throwNullCollectionException("FolderLinks");
        }
        getFolderLinks().addAll( targets );
        java.util.Iterator<ome.model.containers.FolderRoiLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.FolderRoiLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setChild ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.containers.FolderRoiLink
     */
    public void removeFolderRoiLink(ome.model.containers.FolderRoiLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getFolderLinks() == null) {
            throwNullCollectionException("FolderLinks");
        }
        getFolderLinks().remove( target );
            target.setChild ( null );
    }

    /**
     * use like removeFolderRoiLink
     */
    public void removeFolderRoiLinkSet(java.util.Collection<ome.model.containers.FolderRoiLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getFolderLinks() == null) {
            throwNullCollectionException("FolderLinks");
        }
        getFolderLinks().removeAll( targets );
        java.util.Iterator<ome.model.containers.FolderRoiLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.containers.FolderRoiLink target = it.next();
                target.setChild ( null );
        }
    }




    /**
     * Adds a ome.model.containers.FolderRoiLink to folderLinks . This entails changing our folderLinks Set,
     * creating a new ome.model.containers.FolderRoiLink and calling linkFolder on the ome.model.containers.Folder.
     */
    public ome.model.containers.FolderRoiLink linkFolder (ome.model.containers.Folder addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.containers.FolderRoiLink link = new ome.model.containers.FolderRoiLink();
        link.link( addition, this );

        // Add it to us and possibly the other side.
        addFolderRoiLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.containers.FolderRoiLink to folderLinks, allowing for recursion -- whether
     * or not addFolderRoiLink will be called on the addition <b>if it is loaded</b>
     */
    public void addFolderRoiLink (ome.model.containers.FolderRoiLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getFolderLinks() == null ) {
            throwNullCollectionException("FolderLinks");
        }
        getFolderLinks().add( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().addFolderRoiLink( link, false );
        }
    }

    /**
     * provides an iterator over the child values of the folderLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedFolderList()} instead.
     */
     public java.util.Iterator<ome.model.containers.Folder> linkedFolderIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getFolderLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.containers.Folder>();
        }

        final java.util.Iterator<ome.model.containers.FolderRoiLink> it = getFolderLinks().iterator();
        return new java.util.Iterator<ome.model.containers.Folder>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.containers.Folder next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "folderLinks is null; no elements." );
                }
                ome.model.containers.FolderRoiLink link = (ome.model.containers.FolderRoiLink) it.next();
                return link.parent();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.containers.FolderRoiLink which have the argument as their parent.
     */
    public java.util.Set<ome.model.containers.FolderRoiLink> findFolderRoiLink( ome.model.containers.Folder target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.containers.FolderRoiLink> it = iterateFolderLinks();
        final java.util.Set<ome.model.containers.FolderRoiLink> result = new java.util.HashSet<ome.model.containers.FolderRoiLink>();
        while ( it.hasNext() ) {
            ome.model.containers.FolderRoiLink link = it.next();
            if ( link.parent() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedFolderIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.containers.Folder> linkedFolderList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.containers.Folder> it = linkedFolderIterator();
        java.util.List<ome.model.containers.Folder> list = new java.util.ArrayList<ome.model.containers.Folder>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.containers.Folder while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedFolder(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.containers.Folder> it = linkedFolderIterator();
        while ( it.hasNext() ) {
            ome.model.containers.Folder obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.containers.Folder instances from this instance.
     */
    public void unlinkFolder (ome.model.containers.Folder removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.containers.FolderRoiLink> toRemove = findFolderRoiLink( removal );
        java.util.Iterator<ome.model.containers.FolderRoiLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeFolderRoiLink( it.next(), true );
        }
    }

    /**
     * removes the given FolderRoiLink from folderLinks, allowing for recursion -- whether
     * or not the removal will call unlinkRoi again <b>if loaded</b>.
     */
    public void removeFolderRoiLink (ome.model.containers.FolderRoiLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getFolderLinks() == null ) {
            throwNullCollectionException("FolderLinks");
        }

        getFolderLinks().remove( link );

        if ( bothSides && link.parent().isLoaded() ) {
            link.parent().removeFolderRoiLink( link, false );
        }
    }

    /**
     * clears the set.
     */
    public void clearFolderLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.containers.FolderRoiLink> list = new java.util.ArrayList<ome.model.containers.FolderRoiLink>( getFolderLinks() );
        for (ome.model.containers.FolderRoiLink link : list) {
            removeFolderRoiLink( link, true );
        }
    }

    private java.util.Map<Long, Long> folderLinksCountPerOwner = null;

    protected void setFolderLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.folderLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Roi_folderLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.containers.FolderRoiLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Roi_folderLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Roi_folderLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Roi_id"))
    public java.util.Map<Long, Long> getFolderLinksCountPerOwner() {
        return this.folderLinksCountPerOwner;
    }

    protected java.util.Set<ome.model.annotations.RoiAnnotationLink> annotationLinks = new java.util.HashSet<ome.model.annotations.RoiAnnotationLink>();

   /*
    * Filter names which are used by the security system to turn on filters
    * for this particular collection.
    */
    public final static String OWNER_FILTER_ANNOTATIONLINKS = "roi_owner_filter_ANNOTATIONLINKS";
    public final static String GROUP_FILTER_ANNOTATIONLINKS = "roi_group_filter_ANNOTATIONLINKS";
    public final static String EVENT_FILTER_ANNOTATIONLINKS = "roi_event_filter_ANNOTATIONLINKS";
    public final static String PERMS_FILTER_ANNOTATIONLINKS = "roi_perms_filter_ANNOTATIONLINKS";

   /**
    * returns annotationLinks . You should not modify this collection unless you
    * know what you are doing. Use the iterate method instead.
    *
    * one-to-many Set ome.model.roi.Roi.annotationLinks (ome.model.annotations.RoiAnnotationLink)
    */
    @javax.persistence.OneToMany(mappedBy="parent", fetch=javax.persistence.FetchType.LAZY, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
    @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.ALL, org.hibernate.annotations.CascadeType.DELETE_ORPHAN})
    @org.hibernate.annotations.Filters({
        @org.hibernate.annotations.Filter(name="OneGroupSecurityFilter"),
        @org.hibernate.annotations.Filter(name="AllGroupsSecurityFilter"),
        @org.hibernate.annotations.Filter(name="SharingSecurityFilter", condition="(:is_admin = 1 OR :is_share = 0)"),
        @org.hibernate.annotations.Filter(name=OWNER_FILTER_ANNOTATIONLINKS, condition=":ownerId = owner_id"),
        @org.hibernate.annotations.Filter(name=GROUP_FILTER_ANNOTATIONLINKS, condition=":groupId = group_id"),
        @org.hibernate.annotations.Filter(name=EVENT_FILTER_ANNOTATIONLINKS, condition=":eventId = event_id"),
        @org.hibernate.annotations.Filter(name=PERMS_FILTER_ANNOTATIONLINKS, condition=":permsStr = permissions")
    })
    protected java.util.Set<ome.model.annotations.RoiAnnotationLink> getAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks;
    }

    /**
     * setter for annotationLinks should be avoided. Does not fulfill normal semantics.
     */
    protected void setAnnotationLinks(java.util.Set<ome.model.annotations.RoiAnnotationLink> annotationLinks) {
        if (! _loaded ) errorIfUnloaded();
        this.annotationLinks = annotationLinks;
    }
    /**
     * returns the size of annotationLinks. If less than zero, the Set was null.
     */
    public int sizeOfAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        return this.annotationLinks == null ? -1 : this.annotationLinks.size();
    }

    /**
     * should be used rather than accessing the annotationLinks set directly.
     * This method will never return null, but rather will return an instance
     * of {@link ome.util.EmptyIterator}. To test for a null collection,
     * see of {@link #sizeOfAnnotationLinks()} is less than zero.
     */
    public java.util.Iterator<ome.model.annotations.RoiAnnotationLink> iterateAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.RoiAnnotationLink>();
        }
        return getAnnotationLinks().iterator(); // TODO should this be direct access
    }

    /**
     * Returns an unmodifiable collection-view
     */
    public java.util.Collection<ome.model.annotations.RoiAnnotationLink> unmodifiableAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return java.util.Collections.emptyList();
        }
        return java.util.Collections.unmodifiableCollection( getAnnotationLinks() );
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.RoiAnnotationLink while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected. This method uses
     * {@link #iterateAnnotationLinks} internally and so will return a value
     * even if the underlying collection is null.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> collectAnnotationLinks(ome.util.CBlock<E> block) {

        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.RoiAnnotationLink> it = iterateAnnotationLinks();
        while ( it.hasNext() ) {
            IObject obj = (IObject) it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * use instead of setAnnotationLinks . Makes the necessary
     * call on ome.model.annotations.RoiAnnotationLink as well.
     */
    public void addRoiAnnotationLink(ome.model.annotations.RoiAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( target );

        // If this relationship is not ordered, then we will
        // "attempt" the setting even if it is loaded.
        if (target != null) {
                target.setParent ( this );
         }
    }

    /**
     * use like addRoiAnnotationLink.
     */
    public void addRoiAnnotationLinkSet(java.util.Collection<ome.model.annotations.RoiAnnotationLink> targets) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
           throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().addAll( targets );
        java.util.Iterator<ome.model.annotations.RoiAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.RoiAnnotationLink target = it.next();

            // If this relationship is not ordered, then we will
            // "attempt" the setting even if it is loaded.
            if (target != null) {
                    target.setParent ( this );
            }
        }
    }

    /**
     * removes a single element from this set and makes the inverse call on ome.model.annotations.RoiAnnotationLink
     */
    public void removeRoiAnnotationLink(ome.model.annotations.RoiAnnotationLink target) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().remove( target );
            target.setParent ( null );
    }

    /**
     * use like removeRoiAnnotationLink
     */
    public void removeRoiAnnotationLinkSet(java.util.Collection<ome.model.annotations.RoiAnnotationLink> targets ) {
        if (! _loaded ) errorIfUnloaded();
        if (getAnnotationLinks() == null) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().removeAll( targets );
        java.util.Iterator<ome.model.annotations.RoiAnnotationLink> it = targets.iterator();
        while ( it.hasNext() ) {
            ome.model.annotations.RoiAnnotationLink target = it.next();
                target.setParent ( null );
        }
    }




    /**
     * Adds a ome.model.annotations.RoiAnnotationLink to annotationLinks . This entails changing our annotationLinks Set,
     * creating a new ome.model.annotations.RoiAnnotationLink and calling linkAnnotation on the ome.model.annotations.Annotation.
     */
    public ome.model.annotations.RoiAnnotationLink linkAnnotation (ome.model.annotations.Annotation addition) {
        if (! _loaded ) errorIfUnloaded();

        // Setup link
        ome.model.annotations.RoiAnnotationLink link = new ome.model.annotations.RoiAnnotationLink();
        link.link( this, addition );

        // Add it to us and possibly the other side.
        addRoiAnnotationLink( link, true );
        return link;
    }

    /**
     * Adds a ome.model.annotations.RoiAnnotationLink to annotationLinks, allowing for recursion -- whether
     * or not addRoiAnnotationLink will be called on the addition <b>if it is loaded</b>
     */
    public void addRoiAnnotationLink (ome.model.annotations.RoiAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }
        getAnnotationLinks().add( link );

    }

    /**
     * provides an iterator over the parent values of the annotationLinks. Like
     * with most Collection iterators, modifications to the underlying collection
     * while iterating will result in an {@link java.util.ConcurrentModificationException}.
     * Use {@link #linkedAnnotationList()} instead.
     */
     public java.util.Iterator<ome.model.annotations.Annotation> linkedAnnotationIterator() {
        if (! _loaded ) errorIfUnloaded();
        if ( getAnnotationLinks() == null ) {
            return new ome.util.EmptyIterator<ome.model.annotations.Annotation>();
        }

        final java.util.Iterator<ome.model.annotations.RoiAnnotationLink> it = getAnnotationLinks().iterator();
        return new java.util.Iterator<ome.model.annotations.Annotation>() {

            @Override
            public boolean hasNext() {
                return it == null ? false : it.hasNext();
            }

            @Override
            public ome.model.annotations.Annotation next() {
                if ( it == null ) {
                    throw new java.util.NoSuchElementException( "annotationLinks is null; no elements." );
                }
                ome.model.annotations.RoiAnnotationLink link = (ome.model.annotations.RoiAnnotationLink) it.next();
                return link.child();
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException("Cannot call remove on this iterator.");
            }

        };
    }

    /**
     * find all ome.model.annotations.RoiAnnotationLink which have the argument as their child.
     */
    public java.util.Set<ome.model.annotations.RoiAnnotationLink> findRoiAnnotationLink( ome.model.annotations.Annotation target ) {
        if (! _loaded ) errorIfUnloaded();

        final java.util.Iterator<ome.model.annotations.RoiAnnotationLink> it = iterateAnnotationLinks();
        final java.util.Set<ome.model.annotations.RoiAnnotationLink> result = new java.util.HashSet<ome.model.annotations.RoiAnnotationLink>();
        while ( it.hasNext() ) {
            ome.model.annotations.RoiAnnotationLink link = it.next();
            if ( link.child() == target ) {
                result.add( link );
            }
        }
        return result;
    }

    /**
     * produces a {@link java.util.List}-copy of the underlying collection. Unlike,
     * {@link #linkedAnnotationIterator()}, while using the returned {@link java.util.List},
     * modifications can be made to the underlying collection without throwing
     * {@link java.util.ConcurrentModificationException}.
     */
    public java.util.List<ome.model.annotations.Annotation> linkedAnnotationList() {
        if (! _loaded ) errorIfUnloaded();

        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        java.util.List<ome.model.annotations.Annotation> list = new java.util.ArrayList<ome.model.annotations.Annotation>();

        while ( it.hasNext() ) {
            list.add( it.next() );
        }
        return list;
    }

    /**
     * takes a CBlock and calls the block once for each ome.model.annotations.Annotation while
     * collecting the results. If <code>block == null</code>, then the
     * iterator values themselves are collected.
     */
    @SuppressWarnings("unchecked")
    public <E> java.util.List<E> eachLinkedAnnotation(ome.util.CBlock<E> block) {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<E> result = new java.util.ArrayList<E>();
        java.util.Iterator<ome.model.annotations.Annotation> it = linkedAnnotationIterator();
        while ( it.hasNext() ) {
            ome.model.annotations.Annotation obj = it.next();
            if ( block != null ) {
                result.add( block.call( obj ) );
            } else {
                result.add( (E) obj );
            }
        }
        return result;
    }

    /**
     * unlinks all ome.model.annotations.Annotation instances from this instance.
     */
    public void unlinkAnnotation (ome.model.annotations.Annotation removal) {
        if (! _loaded ) errorIfUnloaded();

        java.util.Set<ome.model.annotations.RoiAnnotationLink> toRemove = findRoiAnnotationLink( removal );
        java.util.Iterator<ome.model.annotations.RoiAnnotationLink> it = toRemove.iterator();
        while ( it.hasNext() ) {
            removeRoiAnnotationLink( it.next(), true );
        }
    }

    /**
     * removes the given RoiAnnotationLink from annotationLinks, allowing for recursion -- whether
     * or not the removal will call unlinkRoi again <b>if loaded</b>.
     */
    public void removeRoiAnnotationLink (ome.model.annotations.RoiAnnotationLink link, boolean bothSides) {
        if (! _loaded ) errorIfUnloaded();

        if ( getAnnotationLinks() == null ) {
            throwNullCollectionException("AnnotationLinks");
        }

        getAnnotationLinks().remove( link );

    }

    /**
     * clears the set.
     */
    public void clearAnnotationLinks() {
        if (! _loaded ) errorIfUnloaded();

        java.util.List<ome.model.annotations.RoiAnnotationLink> list = new java.util.ArrayList<ome.model.annotations.RoiAnnotationLink>( getAnnotationLinks() );
        for (ome.model.annotations.RoiAnnotationLink link : list) {
            removeRoiAnnotationLink( link, true );
        }
    }

    private java.util.Map<Long, Long> annotationLinksCountPerOwner = null;

    protected void setAnnotationLinksCountPerOwner(java.util.Map<Long, Long> map) {
        this.annotationLinksCountPerOwner = map;
    }

    /* DISABLED:
    @org.hibernate.annotations.CollectionOfElements()
    @org.hibernate.annotations.MapKey(columns=@javax.persistence.Column(name="owner_id"))
    @javax.persistence.JoinTable(name="count_Roi_annotationLinks_by_owner")
    */
    /**
     * If fetched, returns the count(*) of ome.model.annotations.RoiAnnotationLink that a user has.
     * If unfetched, returns null. No entries in the collection should be null.
     */
    @org.hibernate.annotations.Persister(impl = ome.util.CountCollectionPersister.class) // prevents deletes
    @org.hibernate.annotations.ForeignKey(name="FK_count_to_Roi_annotationLinks") // for code-gen
    @javax.persistence.ElementCollection // new collection annotation
    @javax.persistence.MapKeyColumn(name="owner_id", insertable=false, updatable=false, nullable=false)
    @javax.persistence.Column(name="count", insertable=false, updatable=false, nullable=false)
    @javax.persistence.CollectionTable(name="count_Roi_annotationLinks_by_owner",
        joinColumns = @javax.persistence.JoinColumn(name="Roi_id"))
    public java.util.Map<Long, Long> getAnnotationLinksCountPerOwner() {
        return this.annotationLinksCountPerOwner;
    }

    protected java.lang.String description = null;

   /**
    * Simple field ome.model.roi.Roi.description (java.lang.String) 
    */
    @org.hibernate.annotations.Type(type="org.hibernate.type.TextType")
    @org.hibernate.search.annotations.Fields({
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED),
        @org.hibernate.search.annotations.Field(index = org.hibernate.search.annotations.Index.TOKENIZED, 
            name="combined_fields")
    })

    @javax.persistence.Column(columnDefinition="", nullable=true, unique=false, name="description", updatable=true)
    public java.lang.String getDescription() {
        if (! _loaded ) errorIfUnloaded();
        return this.description;
    }

    public void setDescription(java.lang.String description) {
        if (! _loaded ) errorIfUnloaded();
        this.description = (java.lang.String) description;
    }
    protected ome.model.internal.Details details = new Details();

 
   /**
    * The details of this object correspond to low-level system
    * information. Owner, permissions, Details is always guaranteed
    * to be non-null, unless the user actively nulls it.
    *
    * Every entity also contains a Detail reference, which doesn't
    * refer to a separate table but rather to a collection of fields
    * collected into a Hibernate "component" which is embedded in the
    * object.
    *
    * HQL queries which refer to the Details component cannot directly
    * fetch the entity like this:
    *
    *    select o from Object join fetch o.details
    *
    * but rather each field of the Details instance must be explicitly
    * joined:
    *
    *    select o from Object join fetch o.details.owner
    *
    * It should also be noted that not all types have all the fields
    * which are present on Details. For example,
    *
    *    select e from Experimenter e join fetch e.details.owner
    *
    * will fail. Experimenter has no owner, for obvious reasons.
    *
    * Note: subclasses of this class will return a subclass of
    * the {@link ome.model.internal.Details} type.
    */
    @javax.persistence.Embedded
    @org.hibernate.annotations.Target(Details.class)
    @Override
    public ome.model.internal.Details getDetails() {
        if (! _loaded ) errorIfUnloaded();
        return this.details;
    }

   /**
    * Use the {@link ome.model.internal.Details#copy(ome.model.internal.Details)}
    * or {@link ome.model.internal.Details#shallowCopy(ome.model.internal.Details)}
    * methods to set the {@link Details} instance instead.
    */
    protected void setDetails(ome.model.internal.Details details) {
        if (! _loaded ) errorIfUnloaded();
        this.details = (Details) details;
    }



    @javax.persistence.Transient
    // TODO what does this look like with Validator
    @Override
    public boolean isValid() {
        return ome.util.Validator.validate(this).isValid();
    }

    @Override
    public ome.util.Validation validate() {
        return ome.util.Validator.validate(this);
    }

    public ome.model.roi.Roi newInstance()
    {
        return new ome.model.roi.Roi();
    }

    public ome.model.roi.Roi proxy() {
        return new ome.model.roi.Roi(this.id, false);
    }

    @Override
    public boolean acceptFilter(ome.util.Filter __filter){
        try {
            this.id = (Long) __filter.filter(ID, this.id);
            this.version = (Integer) __filter.filter(VERSION, this.version);
            this.name = (java.lang.String) __filter.filter(NAME, this.name );
            this.shapes = (java.util.List<ome.model.roi.Shape>) __filter.filter(SHAPES, this.shapes );
            this.image = (ome.model.core.Image) __filter.filter(IMAGE, this.image );
            this.source = (ome.model.core.OriginalFile) __filter.filter(SOURCE, this.source );
            this.folderLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(FOLDERLINKSCOUNTPEROWNER, this.folderLinksCountPerOwner );
            this.folderLinks = (java.util.Set<ome.model.containers.FolderRoiLink>) __filter.filter(FOLDERLINKS, this.folderLinks );
            this.annotationLinksCountPerOwner = (java.util.Map<Long, Long>) __filter.filter(ANNOTATIONLINKSCOUNTPEROWNER, this.annotationLinksCountPerOwner );
            this.annotationLinks = (java.util.Set<ome.model.annotations.RoiAnnotationLink>) __filter.filter(ANNOTATIONLINKS, this.annotationLinks );
            this.description = (java.lang.String) __filter.filter(DESCRIPTION, this.description );
            this.details = (ome.model.internal.Details) __filter.filter(DETAILS, this.details );
            return true;
        } catch (RuntimeException re) {
                // ticket:1183 - Caused by Utils.trueClass(Annotation.class)
                if (re.getCause() instanceof InstantiationException) {
                        this.unload();
                        return true;
                } else {
                        throw re;
                }
        }
    }

    @Override
    public String toString() {
        String name = this.getClass().getName();
        StringBuilder sb = new StringBuilder(name.length() + 24);
        sb.append(name);
        if (this.id == null) {
            sb.append(":Hash_");
            sb.append(this.hashCode());
        } else {
            sb.append(":Id_");
            sb.append(this.id);
        }
        return sb.toString();
    }

    // FIELD-FIELDS

    @Override
    public java.util.Set<String> fields() {
        return ome.model.roi.Roi.FIELDS;
    }

    public final static String NAME = "ome.model.roi.Roi_name";
    public final static String SHAPES = "ome.model.roi.Roi_shapes";
    public final static String IMAGE = "ome.model.roi.Roi_image";
    public final static String SOURCE = "ome.model.roi.Roi_source";
    public final static String FOLDERLINKSCOUNTPEROWNER = "ome.model.roi.Roi_folderLinksCountPerOwner";
    public final static String FOLDERLINKS = "ome.model.roi.Roi_folderLinks";
    public final static String ANNOTATIONLINKSCOUNTPEROWNER = "ome.model.roi.Roi_annotationLinksCountPerOwner";
    public final static String ANNOTATIONLINKS = "ome.model.roi.Roi_annotationLinks";
    public final static String DESCRIPTION = "ome.model.roi.Roi_description";
    public final static String DETAILS = "ome.model.roi.Roi_details";

    public final static java.util.Set<String> FIELDS;
    static {
       java.util.Set<String> raw = new java.util.HashSet<String>();
       raw.add(ID);
       raw.add(VERSION);
       raw.add(NAME);
       raw.add(SHAPES);
       raw.add(IMAGE);
       raw.add(SOURCE);
       raw.add(FOLDERLINKSCOUNTPEROWNER);
       raw.add(FOLDERLINKS);
       raw.add(ANNOTATIONLINKSCOUNTPEROWNER);
       raw.add(ANNOTATIONLINKS);
       raw.add(DESCRIPTION);
       raw.add(DETAILS);
       FIELDS = java.util.Collections.unmodifiableSet( raw );
    }

    // Dynamic Getter/Setter
    // TODO is this searched for proxies?
    @javax.persistence.Transient
    protected java.util.Map<String, Object> _dynamicFields;

    @Override
    public Object retrieve(String field) {
        if (field == null) {
            return null;
        } else if (field.equals(ID)) {
             return getId();
        } else if (field.equals(VERSION)) {
             return getVersion();
        } else if (field.equals(NAME)) {
            return getName();
        } else if (field.equals(SHAPES)) {
            return getShapes();
        } else if (field.equals(IMAGE)) {
            return getImage();
        } else if (field.equals(SOURCE)) {
            return getSource();
        } else if (field.equals(FOLDERLINKSCOUNTPEROWNER)) {
            return getFolderLinksCountPerOwner();
        } else if (field.equals(FOLDERLINKS)) {
            return getFolderLinks();
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            return getAnnotationLinksCountPerOwner();
        } else if (field.equals(ANNOTATIONLINKS)) {
            return getAnnotationLinks();
        } else if (field.equals(DESCRIPTION)) {
            return getDescription();
        } else if (field.equals(DETAILS)) {
            return getDetails();
        } else {
            if (_dynamicFields != null) {
                return _dynamicFields.get(field);
            }
            return null;
        }
    }

    @Override
    public void putAt(String field, Object value)
    {
        if (field == null) {
            return;
        } else if (field.equals(ID)) {
             setId((Long) value);
        } else if (field.equals(VERSION)) {
             setVersion((Integer) value);
        } else if (field.equals(NAME)) {
            setName((java.lang.String)value);
        } else if (field.equals(SHAPES)) {
            setShapes((java.util.List<ome.model.roi.Shape>)value);
        } else if (field.equals(IMAGE)) {
            setImage((ome.model.core.Image)value);
        } else if (field.equals(SOURCE)) {
            setSource((ome.model.core.OriginalFile)value);
        } else if (field.equals(FOLDERLINKSCOUNTPEROWNER)) {
            setFolderLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(FOLDERLINKS)) {
            setFolderLinks((java.util.Set<ome.model.containers.FolderRoiLink>)value);
        } else if (field.equals(ANNOTATIONLINKSCOUNTPEROWNER)) {
            setAnnotationLinksCountPerOwner((java.util.Map<Long,Long>)value);
        } else if (field.equals(ANNOTATIONLINKS)) {
            setAnnotationLinks((java.util.Set<ome.model.annotations.RoiAnnotationLink>)value);
        } else if (field.equals(DESCRIPTION)) {
            setDescription((java.lang.String)value);
        } else if (field.equals(DETAILS)) {
            setDetails((ome.model.internal.Details)value);
        } else {
            if (_dynamicFields == null) {
                _dynamicFields = new java.util.HashMap<String, Object>();
            }
            _dynamicFields.put(field,value);
        }
    }

    @javax.persistence.Transient
    protected boolean _loaded = true;

    @javax.persistence.Transient
    @Override
    public boolean isLoaded() {
        return _loaded;
    }

    protected void errorIfUnloaded() {
        throw new IllegalStateException("Object unloaded:"+this);
    }


    @Override
    public void unload() {
        _loaded = false;
        this.version = null;
        this.name = null;
        this.shapes = null;
        this.image = null;
        this.source = null;
        this.folderLinksCountPerOwner = null;
        this.folderLinks = null;
        this.annotationLinksCountPerOwner = null;
        this.annotationLinks = null;
        this.description = null;
        this.details = null;
    }

    @javax.persistence.Transient
    private transient ome.model.internal.GraphHolder _graphHolder;

    @javax.persistence.Transient
    @Override
    public final ome.model.internal.GraphHolder getGraphHolder()
    {
        if (_graphHolder == null)
            _graphHolder = new ome.model.internal.GraphHolder();
        return _graphHolder;
    }



    protected void throwNullCollectionException(String propertyName) {
        throw new ApiUsageException(
            "Error updating collection:" + propertyName +"\n"+
            "Collection is currently null. This can be seen\n"+
            "by testing \"sizeOf"+ propertyName +" < 0\". This implies\n"+
            "that this collection was unloaded. Please refresh this object\n"+
            "in order to update this collection.\n"
            );
    }





    public static class Details extends ome.model.internal.Details {

        private final static long serialVersionUID = 0000000030000020301L;

        public Details() {
            super();
        }

        public Details(Object[] contexts) {
            super(contexts);
        }

        @Override
        public ome.model.internal.Details newInstance() {
            return new Details(contexts);
        }

        @Override
        @javax.persistence.Embedded
        public ome.model.internal.Permissions getPermissions() {
            return super.getPermissions();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "external_id", nullable = true, unique = true, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKroi_external_id_externalinfo")
        public ome.model.meta.ExternalInfo getExternalInfo() {
            return super.getExternalInfo();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "owner_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKroi_owner_id_experimenter")
        public ome.model.meta.Experimenter getOwner() {
            return super.getOwner();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "creation_id", nullable = false, unique = false, insertable = true, updatable = false)
        @org.hibernate.annotations.ForeignKey(name = "FKroi_creation_id_event")
        public ome.model.meta.Event getCreationEvent() {
            return super.getCreationEvent();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "group_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKroi_group_id_experimentergroup")
        public ome.model.meta.ExperimenterGroup getGroup() {
            return super.getGroup();
        }

        @Override
        @javax.persistence.ManyToOne(fetch = javax.persistence.FetchType.LAZY, cascade = {javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH})
        @org.hibernate.annotations.Cascade({org.hibernate.annotations.CascadeType.LOCK, org.hibernate.annotations.CascadeType.MERGE, org.hibernate.annotations.CascadeType.PERSIST, org.hibernate.annotations.CascadeType.REPLICATE, org.hibernate.annotations.CascadeType.REFRESH, org.hibernate.annotations.CascadeType.SAVE_UPDATE, org.hibernate.annotations.CascadeType.EVICT})
        @javax.persistence.JoinColumn(name = "update_id", nullable = false, unique = false, insertable = true, updatable = true)
        @org.hibernate.annotations.ForeignKey(name = "FKroi_update_id_event")
        public ome.model.meta.Event getUpdateEvent() {
            return super.getUpdateEvent();
        }


    }
}
